/*
 * File:   __GP22GAS_IR_APP_C
 * Author:
 *
 * Created on2016-3-7
 */

#ifdef __cplusplus
extern "C"
{
#endif
	

#include "UWater_ir_app.h"
#include "UWater_frame_app.h"
#include "UWater_timer1uS_driver.h"
#include "UWater_uart_driver.h"
#include "UWater_lcd_app.h"
#include "UWater_key_app.h"
#include "UWater_DebugPrint.h"
	
u8 s_g_ir_control_state = IR_CONTROL_S0;
u8 s_g_ir_state = 0;

/************************************************
Function: void UartIrOpen()
Description: 򿪺
Input:
return: 
Others:
 *************************************************/
void UartIrOpen(void)
{

    IR_38KCarrier_Close();
    
    Gpio_WriteOutputIO(IR_UART_CTL_PORT, IR_UART_CTL_PIN, FALSE);
    UartInit(IR_UART_COM, BAUD2400, DATA_BIT_8, STOPBIT_1, UART_EVEN_PARITY, UART_LPUART_Disable);
}

/************************************************
Function: void UartIrClose()
Description: رպ
Input:
return: 
Others:
 *************************************************/
void UartIrClose(void)
{
//    Sysctrl_SetPeripheralGate(SysctrlPeripheralBaseTim, FALSE); //Base Timerʱӹر
	Bt_M0_Stop(TIM2);
				
	UartPreSleep(IR_UART_COM);
	Gpio_WriteOutputIO(IR_UART_CTL_PORT, IR_UART_CTL_PIN, TRUE);//Դƽſ©ߣģϵ	
	
	//úRXΪͣΪ˷ֹоƬ©	
	stc_gpio_cfg_t stcGpioCfg;
	DDL_ZERO_STRUCT(stcGpioCfg);	
	stcGpioCfg.enDir = GpioDirOut;    ///< ˿ڷ	
	stcGpioCfg.enDrv = GpioDrvL;      ///< ˿->	
	stcGpioCfg.enPu = GpioPuDisable;  ///< ˿->
	stcGpioCfg.enPd = GpioPdDisable;	
	stcGpioCfg.enOD = GpioOdDisable;  ///< ˿ڿ©
	stcGpioCfg.enCtrlMode = GpioAHB;  ///< ˿/ֵĴ߿ģʽ->AHB
	Gpio_Init(LPUART0_RX_PORT, LPUART0_RX_PIN, &stcGpioCfg);
	Gpio_WriteOutputIO(LPUART0_RX_PORT, LPUART0_RX_PIN, FALSE);	
	Gpio_Init(LPUART0_TX_PORT, LPUART0_TX_PIN, &stcGpioCfg);
	Gpio_WriteOutputIO(LPUART0_TX_PORT, LPUART0_TX_PIN, TRUE);	//TXҲΪ
    Gpio_Init(IR_38K_PORT, IR_38K_PIN, &stcGpioCfg);
    Gpio_SetAfMode(IR_38K_PORT,IR_38K_PIN,GpioAf0); //ͨIO
	Gpio_WriteOutputIO(IR_38K_PORT, IR_38K_PIN, TRUE);//38KΪ
   
}
	
/************************************************
Function: void IrInitApp()
Description: ʼ
Input:
return: 
Others:
 *************************************************/
void IrInitApp(void)
{	
    IR_Uart_38K_Config();

    //< RX ƽųʼ
	stc_gpio_cfg_t stcGpioCfg;
	DDL_ZERO_STRUCT(stcGpioCfg);	
	stcGpioCfg.enDir = GpioDirOut;    ///< ˿ڷ	
	stcGpioCfg.enDrv = GpioDrvL;      ///< ˿->	
	stcGpioCfg.enPu = GpioPuDisable;  ///< ˿->
	stcGpioCfg.enPd = GpioPdDisable;	
	stcGpioCfg.enOD = GpioOdEnable;  ///< ˿ڿ©
	stcGpioCfg.enCtrlMode = GpioAHB;  ///< ˿/ֵĴ߿ģʽ->AHB	
	Gpio_Init(IR_UART_CTL_PORT, IR_UART_CTL_PIN, &stcGpioCfg);	
	Gpio_WriteOutputIO(IR_UART_CTL_PORT, IR_UART_CTL_PIN, TRUE);	

	UartIrOpen();    
	s_g_ir_control_state = IR_CONTROL_S0;
	FrameSetMsgApp(MsgOpenIr);
}

/************************************************
Function: IrIfSleepApp()
Description: ѯӦòģǷ
Input:
return: 1     0
Others:
 *************************************************/
u8 IrIfSleepApp(void)
{
	if( IR_CONTROL_S0 == s_g_ir_control_state)
    {
        return TRUE;
    }
    return FALSE;
}
u8 IrIfInS0WakeTime(void)
{
	if(s_g_ir_control_state == IR_CONTROL_S0)
	{
		return TRUE;
	}
	return FALSE;
}
/************************************************
Function: IrMachineApp()
Description: 
Input:
return: 
Others:
 *************************************************/
void IrMachineApp(void)
{
	switch (s_g_ir_control_state)
	{
		case IR_CONTROL_S0:
		{
			if(FrameCheckMsgApp(MsgOpenIr))
			{
				FrameClearMsgApp(MsgOpenIr);
				Set100msTimer(TIMER_100MS_IR_OPEN, 600);//λ֮ʱ60,ر
				s_g_ir_control_state = IR_CONTROL_S1;
			}
			else if(KeyCheckIrOpenMsg() == TRUE )//⵽Ϣ
			{
				KeyClearIrOpenMsg();//Ϣ
				Set100msTimer(TIMER_100MS_IR_OPEN, 200);//Ѷʱ20,ر
				s_g_ir_control_state = IR_CONTROL_S1;
			}
			break;
		}
		case IR_CONTROL_S1:
		{
				if(TASK_IDLE == UartIfIdle(IR_UART_COM))
				{
					UartIrOpen();
					s_g_ir_control_state  = IR_CONTROL_S2;
				}
			
			break;
		}
		case IR_CONTROL_S2:
		{
			//Ǽ춨ʱ䵽
			if((0 == Check100msTimer(TIMER_100MS_IR_OPEN)) && 
				(TASK_IDLE == UartIfIdle(IR_UART_COM))&&
				(10 == LcdCheckStateApp())&&
				(FALSE ==GetPrintNbDataSwitch()&&
				(FrameIfSleepApp() == TRUE)))
			{
				UartIrClose();
				KeyClearIrOpenMsg();//Ϣ
				s_g_ir_control_state  = IR_DEAL_S0;
			}
			break;
		}
		default:
		{
			s_g_ir_control_state  = IR_DEAL_S0;
			break;
		}
	}
}
/*************************************************
Function: static void IR_Uart_38K_Config(void)
Description: 38K PWMؼĴ
Input:  
Return: 
Others: 
*************************************************/
void IR_Uart_38K_Config(void)
{
#if IR_38K_OPEN    
    u16 u16ArrValue;
    u16 u16CntValue;
	u16 u16Period;
    stc_bt_mode0_cfg_t stcBtBaseCfg;
	stc_gpio_cfg_t stcTIM1APort;	  
	
    DDL_ZERO_STRUCT(stcTIM1APort);  
	DDL_ZERO_STRUCT(stcBtBaseCfg);
    //PA03ΪTIM2_CHB
    stcTIM1APort.enDir  = GpioDirOut;
    Gpio_Init(IR_38K_PORT, IR_38K_PIN, &stcTIM1APort);
    Gpio_SetAfMode(IR_38K_PORT,IR_38K_PIN,IR_38K_AF); 	
    Sysctrl_SetPeripheralGate(SysctrlPeripheralBaseTim, TRUE); //Base Timerʱʹ
    
    stcBtBaseCfg.enWorkMode = BtWorkMode0;                  //ʱģʽ
    stcBtBaseCfg.enCT       = BtTimer;                      //ʱܣʱΪڲPCLK
    stcBtBaseCfg.enPRS      = BtPCLKDiv1;                   //PCLK/3
    stcBtBaseCfg.enCntMode  = Bt16bitArrMode;               //Զ16λ/ʱ
    stcBtBaseCfg.bEnTog     = TRUE;
    stcBtBaseCfg.bEnGate    = FALSE;
    stcBtBaseCfg.enGateP    = BtGatePositive;
    
    Bt_Mode0_Init(TIM2, &stcBtBaseCfg);                     //TIM2 ģʽ0ܳʼ8 *
    
	u16Period = Sysctrl_GetPClkFreq() /(2 * 38000); 
    u16ArrValue = 0x10000 - u16Period;
    Bt_M0_ARRSet(TIM2, u16ArrValue);                        //ֵ(ARR = 0x10000 - )    
    u16CntValue = 0x10000 - u16Period;    
    Bt_M0_Cnt16Set(TIM2, u16CntValue);                      //üֵ    
    Bt_M0_Enable_Output(TIM2, TRUE);                         //TIM2 ˿ʹ
		
#endif	
}
//
void IR_Uart_38K_PreSleep(void)
{
	Sysctrl_SetPeripheralGate(SysctrlPeripheralBaseTim, FALSE); //Base Timerʱӹر
	Bt_M0_Stop(TIM2);			

	Gpio_WriteOutputIO(IR_UART_CTL_PORT, IR_UART_CTL_PIN, TRUE);//Դƽſ©ߣģϵ	
	
	//úRXΪͣΪ˷ֹоƬ©	
	stc_gpio_cfg_t stcGpioCfg;
	DDL_ZERO_STRUCT(stcGpioCfg);	
	stcGpioCfg.enDir = GpioDirOut;    ///< ˿ڷ	
	stcGpioCfg.enDrv = GpioDrvL;      ///< ˿->	
	stcGpioCfg.enPu = GpioPuDisable;  ///< ˿->
	stcGpioCfg.enPd = GpioPdDisable;	
	stcGpioCfg.enOD = GpioOdDisable;  ///< ˿ڿ©
	stcGpioCfg.enCtrlMode = GpioAHB;  ///< ˿/ֵĴ߿ģʽ->AHB
	Gpio_Init(LPUART0_RX_PORT, LPUART0_RX_PIN, &stcGpioCfg);
	Gpio_WriteOutputIO(LPUART0_RX_PORT, LPUART0_RX_PIN, FALSE);	
	Gpio_Init(LPUART0_TX_PORT, LPUART0_TX_PIN, &stcGpioCfg);
	Gpio_WriteOutputIO(LPUART0_TX_PORT, LPUART0_TX_PIN, TRUE);	//TXҲΪ
    Gpio_Init(IR_38K_PORT, IR_38K_PIN, &stcGpioCfg);
    Gpio_SetAfMode(IR_38K_PORT,IR_38K_PIN,GpioAf0); //ͨIO
	Gpio_WriteOutputIO(IR_38K_PORT, IR_38K_PIN, TRUE);//38KΪ
}
//
//void IR_Uart_38K_Enable(boolean_t enCmd)
//{
//#if IR_38K_OPEN
//	if(TRUE == enCmd)
//	{ 
//		UartInit(IR_UART_COM,BAUD2400,DATA_BIT_8,STOPBIT_1,UART_EVEN_PARITY,UART_LPUART_Disable);//UART_EVEN_PARITY    UART_NONE_PARITY
//		IR_Uart_38K_Config();
//		Bt_M0_Run(TIM2);        //TIM2 
//				
//		Gpio_WriteOutputIO(IR_UART_CTL_PORT, IR_UART_CTL_PIN, FALSE);		
//	}
//	else
//	{		
//		Gpio_WriteOutputIO(IR_38K_PORT,IR_38K_PIN, TRUE);//38KΪ
//		Gpio_WriteOutputIO(IR_UART_CTL_PORT, IR_UART_CTL_PIN, TRUE);//Դƽſ©ߣģϵ			
//		//úRXΪͣΪ˷ֹоƬ©	
//		stc_gpio_cfg_t stcGpioCfg;
//		DDL_ZERO_STRUCT(stcGpioCfg);	
//		stcGpioCfg.enDir = GpioDirOut;    ///< ˿ڷ	
//		stcGpioCfg.enDrv = GpioDrvL;      ///< ˿->	
//		stcGpioCfg.enPu = GpioPuDisable;  ///< ˿->
//		stcGpioCfg.enPd = GpioPdDisable;	
//		stcGpioCfg.enOD = GpioOdDisable;  ///< ˿ڿ©
//		stcGpioCfg.enCtrlMode = GpioAHB;  ///< ˿/ֵĴ߿ģʽ->AHB
//		Gpio_Init(LPUART0_RX_PORT, LPUART0_RX_PIN, &stcGpioCfg);
//		Gpio_WriteOutputIO(LPUART0_RX_PORT, LPUART0_RX_PIN, FALSE);	
//		Gpio_Init(LPUART0_TX_PORT, LPUART0_TX_PIN, &stcGpioCfg);
//		Gpio_WriteOutputIO(LPUART0_TX_PORT, LPUART0_TX_PIN, TRUE);	//TXҲΪ
//		Gpio_WriteOutputIO(IR_38K_PORT, IR_38K_PIN, TRUE);//38KΪ
//	}
//#endif
//}

/*************************************************
Function: void IR_38K_Open(void)
Description: 38K PWMؼĴ,38Kز
Input:  
Return: 
Others: 
*************************************************/
void IR_38KCarrier_Open(void)
{
    IR_Uart_38K_Config();
    Bt_M0_Run(TIM2); 

}

/*************************************************
Function: void IR_38K_Close(void)
Description: ر38KزѸΪ
Input:  
Return: 
Others: 
*************************************************/
void IR_38KCarrier_Close(void)
{
    Bt_M0_Stop(TIM2); 
    stc_gpio_cfg_t stcGpioCfg;
	DDL_ZERO_STRUCT(stcGpioCfg);	
	stcGpioCfg.enDir = GpioDirOut;    ///< ˿ڷ	
	stcGpioCfg.enDrv = GpioDrvL;      ///< ˿->	
	stcGpioCfg.enPu = GpioPuDisable;  ///< ˿->
	stcGpioCfg.enPd = GpioPdDisable;	
	stcGpioCfg.enOD = GpioOdDisable;  ///< ˿ڿ©
	stcGpioCfg.enCtrlMode = GpioAHB;  ///< ˿/ֵĴ߿ģʽ->AHB
    Gpio_Init(IR_38K_PORT, IR_38K_PIN, &stcGpioCfg);
    Gpio_SetAfMode(IR_38K_PORT,IR_38K_PIN,GpioAf0); //ͨIO
	Gpio_WriteOutputIO(IR_38K_PORT, IR_38K_PIN, TRUE);//38KΪ

}




#ifdef __cplusplus
}
#endif		//#ifdef __cplusplus

