/************************************************************************************
 * @Copyright (c)    :(C)2017, Qindao ieslab Co., Ltd
 * @FileName   	     :pic24_nb_driver.c
 * @Author           :QDIES PLATFORM TEAM
 * @Version          :V1.0
 * @Date             :2017-03-01
 * @Description     :
 ************************************************************************************/
#include "sys_config.h"
#ifdef NB_MODULE_E7025

#ifdef	__cplusplus
extern "C"
{
#endif

#include "nb_uart_driver_e7025.h"
#include "nb_driver_e7025.h"
#include "stdio.h"
#include <time.h>
#include "UWater_timer1uS_driver.h"
#include "UWater_uart_driver.h"
#include "UWater_Rtcc_Driver.h"
#include "UWater_frame_app.h"

/********************************************************************/
NBIOT_PARA Nbiot_Para;
NBIOT_MSG Nbiot_Msg;
static NBIOT_SEND_DATA Nbiot_Send_Data;
//static u8 *g_s_csq_value;

//״̬(״̬е״̬)
u8 g_s_nbiot_main_state = NBIOT_S_IDLE;
//u8 s_send_state;

//־λ
u8 g_s_nbiot_task_flag = TASK_INIT;
u8 g_s_nbiot_mode_flag = NO_NBIOT_TASK;
u8 g_s_nbiot_send_type;
u8 g_s_nbiot_read_ccid_flag = FALSE;
u8 g_s_nbiot_read_ECL_flag = FALSE;
u8 flag_clear_ncsearfcn = 0;
u8 nb_power_flag = FALSE;
u8 s_init_state = S_INIT_POWER_ON;
u8 s_coap_connect_state = S_COAP_CONNECT_START;
u8 s_udp_connect_state = S_UDP_CONNECT_START;
u8 s_coap_send_state = S_SEND_START;
u8 s_udp_send_state = S_SEND_START;
u8 s_power_off_state = S_START;
char c_AT_NMGS[40 + UP_BUF_SIZE*2];//ݳȽС

//ipַͶ˿ָ
unsigned char *coap_ip;
u16 coap_port;
unsigned char *udp_ip1;
u16 udp_port1;
unsigned char *udp_ip2;
u16 udp_port2;
u8 nbiot_temp_connect_type=NBIOT_CONNECT_COAP;
/*****************************ڲ״̬***********************************/
void NbiotInitMachine(void);
void CoapConnectMachine(void);
void UdpConnectMachine(void);
void CoapSendDataMachine(void);
void UdpSendDataMachine(void);
void NbiotPowerOffMachine(void);
void UdpReadDataMachine(void);
//static void NbiotMsgDeal(void);
void NbiotReadECLSNRMachine(void);
void StartUdpSendData(void);
void sys_get_three_code (void);
//void sys_get_net_state (void);
void OnenetConnectMachine(void);
void OneNetSendDataMachine(void);
void StartOnenetAckRev(void);
void NbiotRevAckMachine(void);
/*****************************ڲʱӿ**********************************/
void set_timer_1s(u16 time);
u16 check_timer_1s(void);
void set_timer_1ms(u16 time);
u16 check_timer_1ms(void);
void CoapStartConnect(void);
void StartCoapSendData(void);

void StartNbiotInit(void);
void UdpStartConnect(u8 udp_num);

void OneNetStartConnect(void);
void StartOnenetSendData(void);

void TcpStartConnect(void);
void TcpConnectMachine(void);
void TcpSendDataMachine(void);
/*****************************ⲿӿ****************************************/
void NB_Power_Disable(void) 
{
	Gpio_WriteOutputIO(BAT_NB_PORT, BAT_NB_PIN, FALSE);
	nb_power_flag = FALSE;
}

void NB_Power_Enable(void)  
{
	Gpio_WriteOutputIO(BAT_NB_PORT, BAT_NB_PIN, TRUE);
	nb_power_flag = TRUE;
}

u8 If_NB_Poweron(void)
{    
	return nb_power_flag;    
}
/***************************************************************************
* @fun_name     void NbModuleIOInit(void)
* @brief        ģ鹩IOģ鸴λԴPSMųʼ
***************************************************************************/
void NbModuleIOInit(void)
{
    stc_gpio_cfg_t stcGpioCfg;
    DDL_ZERO_STRUCT(stcGpioCfg);
    stcGpioCfg.enDir = GpioDirOut;    ///< ˿ڷ
    stcGpioCfg.enDrv = GpioDrvL;      ///< ˿->
    stcGpioCfg.enPu = GpioPuDisable;  ///< ˿->
    stcGpioCfg.enPd = GpioPdDisable;
    stcGpioCfg.enOD = GpioOdDisable;  ///< ˿ڿ©
    stcGpioCfg.enCtrlMode = GpioAHB;  ///< ˿/ֵĴ߿ģʽ->AHB
    Gpio_Init(BAT_NB_PORT, BAT_NB_PIN, &stcGpioCfg);  //ģ鹩IO
    Gpio_Init(RSTN_NB_PORT, RSTN_NB_PIN, &stcGpioCfg);
    Gpio_Init(NB_PSM_WAKE_PORT, NB_PSM_WAKE_PIN, &stcGpioCfg);
    Gpio_Init(PWR_NB_PORT, PWR_NB_PIN, &stcGpioCfg);   //Դƽ
    Gpio_WriteOutputIO(BAT_NB_PORT, BAT_NB_PIN, FALSE);
    Gpio_WriteOutputIO(PWR_NB_PORT, PWR_NB_PIN, FALSE);
	Gpio_WriteOutputIO(RSTN_NB_PORT, RSTN_NB_PIN, FALSE); 
	Gpio_WriteOutputIO(NB_PSM_WAKE_PORT , NB_PSM_WAKE_PIN, FALSE);
}
/***************************************************************************
 * @fun_name     void NbiotMainMachine()
 * @brief        NBIOTռѭУNBIOT
 ***************************************************************************/
void NbiotMainMachine(void)
{
    switch (g_s_nbiot_main_state)
    {
        case NBIOT_S_IDLE:
		{
			if(TRUE == UdpIfNeedReadData())
			{
				ClearUdpReadDataFlag();
				g_s_nbiot_main_state = NBIOT_READ_UDP_DATA;
			}
			if(TRUE == NbiotGetRevAck())//յONNET·,ȽӦӦһ
			{
				ClearNbiotGetRevAck();
				StartOnenetAckRev();
				g_s_nbiot_main_state = NBIOT_REV_ACK;
			}
		}
        break;

        case NBIOT_POWER_INIT:
        {
            if (TASK_INIT == g_s_nbiot_task_flag) //ǳʼ״̬
            {
                NbiotInitMachine(); //ģʼ״̬
            }
            else if (TASK_SUCCESS == g_s_nbiot_task_flag) //ɹ
            {
				u8 temp_iccid_buf[20];
                NbiotGetICCID((char*)temp_iccid_buf); //йƶΪ:898600;898602;898604;898607 й898603;898611

                if(temp_iccid_buf[4] == '0')
                {
                    if((temp_iccid_buf[5] == '0') || (temp_iccid_buf[5] == '2') || (temp_iccid_buf[5] == '4') || (temp_iccid_buf[5] == '7'))
                    {
                        Nbiot_Para.Telecom = SIM_CARD_MOBILE;
                    }
                }
                Nbiot_Para.net_state = NB_ON_LINE;
				g_s_nbiot_task_flag = TASK_INIT;
				g_s_nbiot_main_state = NBIOT_S_IDLE;
            }
            else //ʧ
            {
                g_s_nbiot_task_flag = TASK_INIT; //־λ
                g_s_nbiot_main_state = NBIOT_S_IDLE; //
            }
        }
        break;

        	case NBIOT_NET_OPEN:
		{
			if (TASK_INIT == g_s_nbiot_task_flag)
            {
				if(nbiot_temp_connect_type == NBIOT_CONNECT_COAP)
				{
					/*if(Nbiot_Para.Telecom == SIM_CARD_MOBILE)//ƶ
					{
						OnenetConnectMachine();//ONNETƽ̨״̬
					}
					else//ſ
					{
						CoapConnectMachine(); //վ״̬	
					}	*/	
					TcpConnectMachine(); //վ״̬
				}
				else if(nbiot_temp_connect_type == NBIOT_CONNECT_UDP1)
				{
					UdpConnectMachine();
				}
				else if(nbiot_temp_connect_type == NBIOT_CONNECT_UDP2)
				{
					UdpConnectMachine();
				}
				/*else if(nbiot_temp_connect_type == NBIOT_CONNECT_COAP)
				{
					TcpConnectMachine(); //վ״̬
				}*/
				else
				{
					g_s_nbiot_task_flag = TASK_INIT;
					g_s_nbiot_main_state = NBIOT_S_IDLE; 
				}
            }
            else if (TASK_SUCCESS == g_s_nbiot_task_flag)
            {
				if(nbiot_temp_connect_type == NBIOT_CONNECT_COAP)
				{
					 Nbiot_Para.coap_state = CONNECT_ON_LINE;	
				}
				else if(nbiot_temp_connect_type == NBIOT_CONNECT_UDP1)
				{
					 Nbiot_Para.udp1_state = CONNECT_ON_LINE;
				}
				else if(nbiot_temp_connect_type == NBIOT_CONNECT_UDP2)
				{
					 Nbiot_Para.udp2_state = CONNECT_ON_LINE;
				}
				/*else if (nbiot_temp_connect_type == NBIOT_CONNECT_TCP1)
				{
					 Nbiot_Para.tcp1_state = CONNECT_ON_LINE;
				} */
				g_s_nbiot_task_flag = TASK_INIT;
                g_s_nbiot_main_state = NBIOT_S_IDLE;
            }
            else
            {
                g_s_nbiot_task_flag = TASK_INIT;
                g_s_nbiot_main_state = NBIOT_S_IDLE; 
            }
		}
		break;

        case NBIOT_DATA_SEND:
        {
			if (g_s_nbiot_task_flag == TASK_INIT)
			{
				if(g_s_nbiot_send_type == SEND_TYPE_COAP)
				{
					/*if(Nbiot_Para.Telecom == SIM_CARD_MOBILE)//ƶ
					{
						OneNetSendDataMachine();
					}
					else//ſ
					{
						CoapSendDataMachine(); //ݷ״̬
					}*/
					TcpSendDataMachine(); //ݷ״̬
				}
				else if(g_s_nbiot_send_type == SEND_TYPE_UDP1)
				{
					UdpSendDataMachine(); //ݷ״̬
				}
				else if(g_s_nbiot_send_type == SEND_TYPE_UDP2)
				{
					UdpSendDataMachine(); //ݷ״̬
				}
				/*else if(g_s_nbiot_send_type == SEND_TYPE_TCP1)
				{
					TcpSendDataMachine(); //ݷ״̬
				}*/
				else
				{
					g_s_nbiot_task_flag = TASK_INIT;
					g_s_nbiot_main_state = NBIOT_S_IDLE; 
				}
			}
			else//ϻص״̬
			{
				g_s_nbiot_task_flag = TASK_INIT;
				g_s_nbiot_main_state = NBIOT_S_IDLE; 
			}
        }
        break;
		
        case NBIOT_POWER_OFF:
        {
            if (TASK_INIT == g_s_nbiot_task_flag)
            {
                NbiotPowerOffMachine(); //ϵػ
            }
            else
            {
				g_s_nbiot_mode_flag = NO_NBIOT_TASK;
                g_s_nbiot_task_flag = TASK_INIT;
                g_s_nbiot_main_state = NBIOT_S_IDLE;
                Nbiot_Para.net_state = NB_OFF_LINE;
				Nbiot_Para.coap_state = CONNECT_OFF_LINE;
				Nbiot_Para.udp1_state = CONNECT_OFF_LINE;
				Nbiot_Para.udp2_state = CONNECT_OFF_LINE;
            }
        }
        break;

		case NBIOT_READ_UDP_DATA:
		{
            if (TASK_INIT == g_s_nbiot_task_flag)
            {
                UdpReadDataMachine(); //
            }
            else
            {
                g_s_nbiot_task_flag = TASK_INIT;
                g_s_nbiot_main_state = NBIOT_S_IDLE;
            }			
        }
        break;
		case NBIOT_REV_ACK:
		{
            if (TASK_INIT == g_s_nbiot_task_flag)
            {
                NbiotRevAckMachine(); //
            }
            else
            {
                g_s_nbiot_task_flag = TASK_INIT;
                g_s_nbiot_main_state = NBIOT_S_IDLE;
            }			
        }
        break;
		

        default:
        {
            g_s_nbiot_main_state = NBIOT_S_IDLE;
        }
        break;
    }
}
/***************************************************************************
 * @fun_name     u8 NbiotIfIdle()
 * @brief        ѯģĿ״̬
 ***************************************************************************/
u8 NbiotIfIdle(void)
{
    if (NBIOT_S_IDLE == g_s_nbiot_main_state)
    {
        return TASK_IDLE;
    }
    else
    {	
        return TASK_BUSY;
    }
}

/***************************************************************************
 * @fun_name     u8 NbiotIfOnline()
 * @brief        ѯNBIOTǷ
 ***************************************************************************/
u8 NbiotIfOnline(void)
{
    if(NB_ON_LINE == Nbiot_Para.net_state)
    {
        return TRUE;
    }
    else
    {
        return FALSE;
    }
}
/***************************************************************************
 * @fun_name     u8 ConncetIfOnline()
 * @brief        ѯǷ
 ***************************************************************************/
u8 ConncetIfOnline(u8 connect_type)
{  
	if(connect_type == NBIOT_CONNECT_COAP)
	{
		if (CONNECT_ON_LINE == Nbiot_Para.coap_state)
		{
			return TRUE;
		}
		else
		{
			return FALSE;
		}
	}
	else if(connect_type == NBIOT_CONNECT_UDP1)
	{
		if (CONNECT_ON_LINE == Nbiot_Para.udp1_state)
		{
			return TRUE;
		}
		else
		{
			return FALSE;
		}
	}
	else if(connect_type == NBIOT_CONNECT_UDP2)
	{
		if (CONNECT_ON_LINE == Nbiot_Para.udp2_state)
		{
			return TRUE;
		}
		else
		{
			return FALSE;
		}
	}
	/*else if(connect_type == NBIOT_CONNECT_TCP1)
	{
		if (CONNECT_ON_LINE == Nbiot_Para.tcp1_state)
		{
			return TRUE;
		}
		else
		{
			return FALSE;
		}
	}*/
	return FALSE;
}
/***************************************************************************
 * @fun_name     void NbiotOnlineTask(u8 *state)
 * @brief        NBIOT
 * @param[in]    state:״̬Ϣ
 ***************************************************************************/
void NbiotOnlineTask(u8 *state)
{
    if (NBIOT_S_IDLE == g_s_nbiot_main_state)
    {
        if (!NbiotIfOnline())
        {
            if (NBIOT_S_IDLE == g_s_nbiot_main_state)
            {
                Nbiot_Send_Data.state = state; //ַ
                *state = NBIOT_ING;
                g_s_nbiot_mode_flag = ONLINE_MODE;
				g_s_nbiot_task_flag = TASK_INIT;
                g_s_nbiot_main_state = NBIOT_POWER_INIT;
				StartNbiotInit();
            }
        }
        else
        {
            *state = NBIOT_ONLINE;
        }
    }
    else
    {
        *state = NBIOT_ERROR;
    }
}
/***************************************************************************
 * @fun_name     void NB_NetConnectStart
 * @brief        ͽ
 * @param[in]    state:״̬Ϣ
 ***************************************************************************/
void NB_NetConnectStart(unsigned char* temp_ip, u16 temp_port, u8 connect_type)
{
	if(connect_type == NBIOT_CONNECT_COAP)
	{
		//Nbiot_Para.Telecom = SIM_CARD_TELECOM;//debug ǿƸΪƽ̨ͨ
		
		coap_ip = temp_ip;
		coap_port = temp_port;
		/*if(Nbiot_Para.Telecom == SIM_CARD_MOBILE)//ƶ
		{
			OneNetStartConnect(); 
		}
		else//ſ
		{
			CoapStartConnect();	
		}*/
		TcpStartConnect();
		nbiot_temp_connect_type = NBIOT_CONNECT_COAP;
	}
	else if(connect_type == NBIOT_CONNECT_UDP1)
	{
		udp_ip1 = temp_ip;
		udp_port1 = temp_port;
		UdpStartConnect(NBIOT_CONNECT_UDP1);
	}
	else if(connect_type == NBIOT_CONNECT_UDP2)
	{
		udp_ip2 = temp_ip;
		udp_port2 = temp_port;
		UdpStartConnect(NBIOT_CONNECT_UDP2);
	}
	/*else if(connect_type == NBIOT_CONNECT_TCP1)
	{
		coap_ip = temp_ip;
		coap_port = temp_port;
		TcpStartConnect();
	}*/
	g_s_nbiot_task_flag = TASK_INIT;
	g_s_nbiot_main_state = NBIOT_NET_OPEN;
}
u8 getNB_NetConnectType(void)
{
	return nbiot_temp_connect_type;
}
/***************************************************************************
 * @fun_name     void NbiotSendTask(u8 *addr, u16 len, u8 send_type,u8 *state)
 * @brief        NBIOTݷ
 * @param[in]    addrݵ׵ַ len
 * @param[out]   state:״̬Ϣ
 * @retval       None
 * @other        state(NBIOT_INGѯ, NBIOT_SUCCESɹ 쳣)
 ***************************************************************************/
void NbiotSendTask(u8 *addr, u16 len, u8 send_type,u8 *state)
{
    if ((NBIOT_S_IDLE == g_s_nbiot_main_state) && (len > 0) && (len <= UP_BUF_SIZE))
    {
        Nbiot_Send_Data.buf = addr; //ַ
        Nbiot_Send_Data.len = len; //ֵ
        Nbiot_Send_Data.state = state; //ַ
        *state = NBIOT_ING;
        g_s_nbiot_mode_flag = SEND_MODE;
		g_s_nbiot_send_type = send_type;
		g_s_nbiot_task_flag = TASK_INIT;
		g_s_nbiot_main_state = NBIOT_DATA_SEND;
		StartNbiotSendData();
    }
    else
    {
        *state = NBIOT_ERROR;
    }
}
//ȡ
u8 GetNbiotSendType(void)
{
	return g_s_nbiot_send_type;	
}
/***************************************************************************
 * @fun_name     void NbiotReadCsqTask(u8 *out_csq,u8 *state)
 * @brief        NBIOTѯźֵ
 * @param[in]    out_csqݵַ
 * @param[out]   state:״̬Ϣ
 * @retval       None
 * @other        state(CSQ_INGѯ, CSQ_SUCCESɹ 쳣)
 ***************************************************************************/
/*void NbiotTcpOpenTask(void)
{
    if (NBIOT_S_IDLE == g_s_nbiot_main_state)
    {
		if(!TcpIfOnline())
		{
			g_s_nbiot_mode_flag = ONLINE_MODE;
			g_s_nbiot_task_flag = TASK_INIT;
			g_s_nbiot_main_state = NBIOT_TCP_OPEN;
			TcpStartConnect();
		}        
    }   	
}*/
void NbiotReadECLSNRTask(u8 *state)
{
    if (NBIOT_S_IDLE == g_s_nbiot_main_state)
    {
        //        g_s_ecl_val = out_ecl;
        Nbiot_Send_Data.state = state;
        *state = ECL_SNR_ING;
        g_s_nbiot_mode_flag = READ_ECL_SNR;
        g_s_nbiot_read_ECL_flag = FALSE;
		g_s_nbiot_task_flag = TASK_INIT;
        g_s_nbiot_main_state = NBIOT_READ_ECL_SNR;
    }
    else
    {
        *state = ECL_SNR_ERROR;
    }
}


/***************************************************************************
 * @fun_name     u8 NbiotIfSleep()
 * @brief        Ƿ
 * @param[in]    None
 * @param[out]   None
 * @retval       TRUE:   FALSE:
 * @other        None
 ***************************************************************************/
u8 NbiotIfSleep(void)
{
    if (NBIOT_S_IDLE == g_s_nbiot_main_state)
    {
        return TRUE;
    }
    else
    {
        return FALSE;
    }
}

/***************************************************************************
 * @fun_name     void NbiotPreSleep()
 * @brief        ǰ
 * @param[in]    None
 * @param[out]   None
 * @retval       None
 * @other        None
 ***************************************************************************/
void NbiotPreSleep(void)
{
    NB_Power_Disable(); //жϵԴ
    UartPreSleep(NB_UART_COM);
    g_s_nbiot_main_state = NBIOT_S_IDLE;
	Nbiot_Para.net_state = NB_OFF_LINE;
	Nbiot_Para.coap_state = CONNECT_OFF_LINE;
	Nbiot_Para.udp1_state = CONNECT_OFF_LINE;
	Nbiot_Para.udp2_state = CONNECT_OFF_LINE;
	//Nbiot_Para.tcp1_state = CONNECT_OFF_LINE;
	
	//NB
	stc_gpio_cfg_t stcGpioCfg;
	DDL_ZERO_STRUCT(stcGpioCfg);	
	stcGpioCfg.enDir = GpioDirOut;    ///< ˿ڷ	
	stcGpioCfg.enDrv = GpioDrvL;      ///< ˿->	
	stcGpioCfg.enPu = GpioPuDisable;  ///< ˿->
	stcGpioCfg.enPd = GpioPdDisable;	
	stcGpioCfg.enOD = GpioOdDisable;  ///< ˿ڿ©
	stcGpioCfg.enCtrlMode = GpioAHB;  ///< ˿/ֵĴ߿ģʽ->AHB
	Gpio_Init(BAT_NB_PORT, BAT_NB_PIN, &stcGpioCfg);  //ģ鹩IO
    Gpio_Init(RSTN_NB_PORT, RSTN_NB_PIN, &stcGpioCfg);
    Gpio_Init(NB_PSM_WAKE_PORT, NB_PSM_WAKE_PIN, &stcGpioCfg);
    Gpio_Init(PWR_NB_PORT, PWR_NB_PIN, &stcGpioCfg);   //Դƽ
	
	Gpio_WriteOutputIO(BAT_NB_PORT, BAT_NB_PIN, FALSE);
    Gpio_WriteOutputIO(PWR_NB_PORT, PWR_NB_PIN, FALSE);
	Gpio_WriteOutputIO(RSTN_NB_PORT, RSTN_NB_PIN, FALSE); 
	Gpio_WriteOutputIO(NB_PSM_WAKE_PORT , NB_PSM_WAKE_PIN, FALSE);	
	
	Gpio_Init(LPUART1_TX_PORT, LPUART1_TX_PIN, &stcGpioCfg);
	Gpio_WriteOutputIO(LPUART1_TX_PORT, LPUART1_TX_PIN, FALSE);	//TXҲΪ
	
	stcGpioCfg.enDir = GpioDirIn;   //RX
	Gpio_Init(LPUART1_RX_PORT, LPUART1_RX_PIN, &stcGpioCfg);
}

/***************************************************************************
 * @fun_name    void NbiotWakeSleep()
 * @brief        ߺ
 * @param[in]    None
 * @param[out]   None
 * @retval       None
 * @other        None
 ***************************************************************************/
void NbiotWakeSleep(void)
{
  
}

/***************************************************************************
 * @fun_name    u8 NbiotOfflineReason()
 * @brief        ѯNBIOTԭ
 * @param[in]    None
 * @param[out]   None
 * @retval       NBIOTı䣻쳣ߣվߣλ
 * @other        None
 ***************************************************************************/
//u8 NbiotOfflineReason(void)
//{
//    return Nbiot_Para.offline_reason;
//}

/******************************ڲ״̬***********************************/
//
void StartNbiotInit(void)
{
	s_init_state = S_INIT_POWER_ON;//
}

/***************************************************************************
 * @fun_name     void NbiotInitMachine()
 * @brief        NBIOTʼ״̬
 * @param[in] 	 None
 * @param[out] 	 None
 * @retval     	 None
 * @other        None
 ***************************************************************************/
#define MODULE_POWER_DELAY_TIME 1000  		//mS
#define MODULE_RESET_DELAY_TIME 1000  		//mS
//AT+QBAND  AT+QBAND=1,5 //ƵΪ BAND 5
//йƶΪ:898600;898602;898604;898607 й898603;898611
void NbiotInitMachine_E7025(void)
{
    static u8 s_at_error_count = 0; //¼ATָʱ  ָΪʧ
    
    static const char* c_ATE1 = "ATE1\r"; //E7025򿪻
    static const char* c_AT_IMEI = "AT+CGSN=1\r";
    static const char* c_AT_CIMI = "AT+CIMI\r";
    static const char* c_AT_ICCID = "AT+ECICCID\r";//E7025
    static const char* c_AT_CMEE = "AT+CMEE=1\r"; //ERRORʾ
    static const char* c_AT_CPSMS = "AT+CPSMS=0\r"; //رPSMģʽ
    static const char* c_AT_NPTWEDRXS = "AT+CEDRXS=0\r"; //رeDRXģʽ
    static const char* c_AT_CSQ = "AT+CSQ\r"; //ѯźֵ
    static const char* c_AT_CEREG = "AT+CEREG?\r";
    static const char* c_AT_CGATT = "AT+CGATT?\r";
	static const char* c_AT_ECCESQS = "AT+ECCESQS=0\r";//رźŸ±
	static const char* c_AT_ECSTATUS = "AT+ECSTATUS\r";//ѯźŵȹؼ
	static u8 c_AT_CGDCONT_APN[APN_SIZE+50] = "AT+CGDCONT=1,\"IP\",\""; //ָAPN,СΪ̶20ֽ+APNСټԤռ
    static const char* c_AT_CFUN0 = "AT+CFUN=0\r"; //Сģʽ
    static const char* c_AT_CFUN1 = "AT+CFUN=1\r"; //ģʽ
	
    switch (s_init_state)
    {
        case S_INIT_POWER_ON://NBģ͵
        {  
			NbModuleIOInit();  //ʼĬģϵ
            UartInit(NB_UART_COM, BAUD9600, DATA_BIT_8, STOPBIT_1, UART_NONE_PARITY,UART_LPUART_Disable);	
            RSTN_NB_LOW();//ģ鸴λʹ
            PWR_NB_HIG();//ʹ
            NB_Power_Enable(); 						//򿪵Դʱ1S,ȴϵȶ
            set_timer_1ms(MODULE_POWER_DELAY_TIME);
            s_init_state = S_INIT_RESET_HIGH;//S_INIT_PWRKEY_LOW;
        }
        break;
        case S_INIT_RESET_HIGH://ɸλNBģ
        {
            if (!check_timer_1ms())
            {
                RSTN_NB_HIG();     //ߵƽ
                s_init_state = S_INIT_POWER_ON_WAIT; //ʱѯCSQCEREGȷע ѽԼʼʱ ͹
                set_timer_1s(5); //ȴNBģע5S --5ʱ䲻 ʱԼ
            }
        }
        break;

        case S_INIT_POWER_ON_WAIT://ȴģעʱ
        {
            if (!check_timer_1s())
            {
                s_at_error_count = 0; //ATָ
                s_init_state = S_INIT_ATS;
                set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
            }
        }
        break;

        case S_INIT_ATS://򿪻, ȷģ
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_ATE1, strlen(c_ATE1), cst_AT_No_AT);
                s_init_state = S_INIT_ATS_R;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME); 
            }
        }
        break;

        case S_INIT_ATS_R://ȴ"ATE1"Ӧ
        {
            if (NbiotCheckAtAck() == UART_OK)//ȷӦ
            {
                s_at_error_count = 0;
                s_init_state = S_INIT_ASK_IMEI; //һʼѯIMEI
                set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
            }
            else if ((!check_timer_1ms()) || (NbiotCheckAtAck() == UART_ERROR)) //Ӧʱߴ
            {
                if (++s_at_error_count >= NUM_AT_ERROR)
                {
                    s_at_error_count = 0;
					s_init_state = S_INIT_ASK_IMEI; //һʼѯIMEI
					set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
                else
                {
                    s_init_state = S_INIT_ATS;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        }
        break;

        case S_INIT_ASK_IMEI: //ʼѯIMEI
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_IMEI, strlen(c_AT_IMEI), cst_AT_No_AT_IMEI);
                s_init_state = S_INIT_ASK_IMEI_R;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME); //ԱATָصʱ300ms(ͺͽռõʱ)
            }
        }
        break;

        case S_INIT_ASK_IMEI_R://ȴIMEIӦ
        {
            if (NbiotCheckAtAck() == UART_OK)//ȷӦ
            {
                s_at_error_count = 0;
                s_init_state = S_INIT_ASK_CIMI;
                set_timer_1ms(2 * AT_COMMAND_SEND_INTERVAL_TIME);
            }
            else if ((!check_timer_1ms()) || (NbiotCheckAtAck() == UART_ERROR))
            {
                if (++s_at_error_count >= NUM_AT_CIMI_ERROR)
                {
                    s_at_error_count = 0;
					s_init_state = S_INIT_ASK_CIMI;
					set_timer_1ms(2 * AT_COMMAND_SEND_INTERVAL_TIME);
                }
                else
                {
                    s_init_state = S_INIT_ASK_IMEI;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        }
        break;

        case S_INIT_ASK_CIMI://ʼѯCIMI
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_CIMI, strlen(c_AT_CIMI), cst_AT_No_AT_CIMI);
                s_init_state = S_INIT_ASK_CIMI_R;
                set_timer_1ms(3*AT_COMMAND_RECEIVE_WAIT_TIME); //ԱATָصʱ300ms(ͺͽռõʱ)
            }
        }
        break;

        case S_INIT_ASK_CIMI_R://ȴCIMIӦ
        {
            if (NbiotCheckAtAck() == UART_OK)//ȷӦ
            {
                s_at_error_count = 0;
                s_init_state = S_INIT_ASK_ICCID; //ʼѯICCID
                set_timer_1ms(2*AT_COMMAND_SEND_INTERVAL_TIME);
            }
            else if ((!check_timer_1ms()) || (NbiotCheckAtAck() == UART_ERROR))
            {
                if (++s_at_error_count >= NUM_AT_CIMI_ERROR)
                {
                    s_at_error_count = 0;
					s_init_state = S_INIT_ASK_ICCID; //ʼѯICCID
					set_timer_1ms(2*AT_COMMAND_SEND_INTERVAL_TIME);
                }
                else
                {
                    s_init_state = S_INIT_ASK_CIMI;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        }
        break;

        case S_INIT_ASK_ICCID://ʼѯICCID
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_ICCID, strlen(c_AT_ICCID), cst_AT_No_AT_ICCID);
                s_init_state = S_INIT_ASK_ICCID_R;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME); //ԱATָصʱ300ms(ͺͽռõʱ)
            }
        }
        break;

        case S_INIT_ASK_ICCID_R://ȴICCIDӦ
        {
            if (NbiotCheckAtAck() == UART_OK)//ȷӦ
            {
                s_at_error_count = 0;
                //IMEI IMSI ICCID תȫRAM
                 sys_get_three_code();
                if(0)//if(0 == Sys_data_object.product_test_state)
                {
					//Sys_data_object.product_test_state = 1; //ƬѾȡ룬ȴȡ
                    s_init_state = S_INIT_POWER_ON;
                    g_s_nbiot_task_flag = TASK_INIT;
					StartPowerOffTask();				    //ùػ
                }
                else
                {
                    s_init_state = S_INIT_CMEE; //һERRORʾ
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
            else if ((!check_timer_1ms()) || (NbiotCheckAtAck() == UART_ERROR))
            {
                if (++s_at_error_count >= NUM_AT_ICCID_ERROR)
                {
                    s_at_error_count = 0;
                    s_init_state = S_INIT_CMEE; //һERRORʾ
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
                else
                {
                    s_init_state = S_INIT_ASK_ICCID;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        }
        break;

        case S_INIT_CMEE: //򿪴ʾ
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_CMEE, strlen(c_AT_CMEE), cst_AT_No_AT_CMEE);
                s_init_state = S_INIT_CMEE_R;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME); 
            }
        }
        break;

        case S_INIT_CMEE_R://ȴCMEEӦ
        {
            if (NbiotCheckAtAck() == UART_OK)//ȷӦ
            {
                s_at_error_count = 0;
                s_init_state = S_TCP_CPSMS;
                set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
            }
            else if ((!check_timer_1ms()) || (NbiotCheckAtAck() == UART_ERROR))
            {
                if (++s_at_error_count >= NUM_AT_CMEE_ERROR)
                {
                    s_at_error_count = 0;
					s_init_state = S_TCP_CPSMS;
					set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
                else
                {
                    s_init_state = S_INIT_CMEE;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        }
        break;

        case S_TCP_CPSMS://ùرPSMģʽ
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_CPSMS, strlen(c_AT_CPSMS), cst_AT_No_AT_CPSMS);
                s_init_state = S_TCP_CPSMS_R;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME);
            }
        }
        break;

        case S_TCP_CPSMS_R:
        {
            if (NbiotCheckAtAck() == UART_OK)//Ӧȷ-һ
            {
                s_at_error_count = 0;
                s_init_state = S_TCP_NPTWEDRXS;
                set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
            }
            else if ((!check_timer_1ms()) || (NbiotCheckAtAck() == UART_ERROR))
            {
                if (++s_at_error_count >= NUM_AT_CPSMS_ERROR)
                {
                    s_at_error_count = 0;
					s_init_state = S_TCP_NPTWEDRXS;
					set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
                else
                {
                    s_init_state = S_TCP_CPSMS;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        }
        break;

        case S_TCP_NPTWEDRXS://رeDRXģʽ
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_NPTWEDRXS, strlen(c_AT_NPTWEDRXS), cst_AT_No_AT_NPTWEDRXS);
                s_init_state = S_TCP_NPTWEDRXS_R;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME);
            }
        }
        break;

        case S_TCP_NPTWEDRXS_R://رeDRXģʽ --ȴӦ
        {
            if (NbiotCheckAtAck() == UART_OK)
            {
                s_at_error_count = 0;
                s_init_state = S_INIT_AT_CGDCONT;
                set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
            }
            else if ((!check_timer_1ms()) || (NbiotCheckAtAck() == UART_ERROR))
            {
                if (++s_at_error_count >= NUM_AT_NPTWEDRXS_ERROR)
                {
                    s_at_error_count = 0;
					s_init_state = S_INIT_AT_CGDCONT;
					set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
                else
                {
                    s_init_state = S_TCP_NPTWEDRXS;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        }
        break;
//////////////////////////////////////////////////////////
        case S_INIT_CFUN0://ģСģʽ
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_CFUN0, strlen((const char*) c_AT_CFUN0), cst_AT_No_AT_CFUN);
                s_init_state = S_INIT_CFUN0_R;
                set_timer_1ms(2 * AT_COMMAND_RECEIVE_WAIT_TIME);
            }
        }
        break;

        case S_INIT_CFUN0_R:
        {
            if (NbiotCheckAtAck() == UART_OK)
            {
                //ȷӦ
                s_at_error_count = 0;
				set_timer_1ms( AT_COMMAND_SEND_INTERVAL_TIME);
                s_init_state = S_INIT_AT_CGDCONT;
            }
            else if (NbiotCheckAtAck() == UART_ERROR || (!check_timer_1ms()))
            {
                //شӦ߶ʱʱ䵽
                if (++s_at_error_count >= NUM_AT_CFUN_ERROR)
                {
                    s_at_error_count = 0;
                    s_init_state = S_INIT_AT_CGDCONT;
                }
                else
                {
                    s_init_state = S_INIT_CFUN0;
                    set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME);
                }
            }
        }
        break;

        case S_INIT_AT_CGDCONT://
        {
			 if(!check_timer_1ms())
            {
                u8 ip_apn = 19;
				int i;
				for(i = 0; i < Sys_data_object.P1.apn[1]; i++)
				{
					c_AT_CGDCONT_APN[ip_apn++] = Sys_data_object.P1.apn[2 + i];
				}
				c_AT_CGDCONT_APN[ip_apn++] = '"';
				c_AT_CGDCONT_APN[ip_apn++] = '\r';
				NbiotUartSend((u8*) c_AT_CGDCONT_APN, ip_apn, cst_AT_No_AT_CGDCONT);
				set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME);
				s_init_state = S_INIT_AT_CGDCONT_R;
            }
        }
        break;

        case S_INIT_AT_CGDCONT_R:
        {
            if (NbiotCheckAtAck() == UART_OK) 
            {
                s_at_error_count = 0;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME);
                s_init_state = S_INIT_ASK_CSQ;
            }
            else if ((NbiotCheckAtAck() == UART_ERROR) || (!check_timer_1ms()))
            {
                s_at_error_count++;
                if (s_at_error_count >= AT_ERROR)
                {
                    s_at_error_count = 0;
                    set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME);
					s_init_state = S_INIT_ASK_CSQ;
                }
                else
                {
                    s_init_state = S_INIT_AT_CGDCONT;
                }
            }
        }
        break;

        case S_INIT_CFUN1://ģģʽ
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_CFUN1, strlen((const char*) c_AT_CFUN1), cst_AT_No_AT_CFUN);
                s_init_state = S_INIT_CFUN1_R;
                set_timer_1ms(2 * AT_COMMAND_RECEIVE_WAIT_TIME);
            }
        }
        break;

        case S_INIT_CFUN1_R:
        {
            if (NbiotCheckAtAck() == UART_OK)
            {
                //ȷӦ
                s_at_error_count = 0;
				set_timer_1ms( AT_COMMAND_SEND_INTERVAL_TIME);
                s_init_state = S_INIT_ASK_CSQ;
            }
            else if (NbiotCheckAtAck() == UART_ERROR || (!check_timer_1ms()))
            {
                //شӦ߶ʱʱ䵽
                if (++s_at_error_count >= NUM_AT_CFUN_ERROR)
                {
                    s_at_error_count = 0;
                    set_timer_1ms( AT_COMMAND_SEND_INTERVAL_TIME);
					s_init_state = S_INIT_ASK_CSQ;
                }
                else
                {
                    s_init_state = S_INIT_CFUN1;
                    set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME);
                }
            }
        }
        break;
//////////////////////////////////////////////
        case S_INIT_ASK_CSQ://ѯCSQ
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_CSQ, strlen(c_AT_CSQ), cst_AT_No_AT_CSQ);
                s_init_state = S_INIT_ASK_CSQ_R;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME); //ԱATָصʱ300ms(ͺͽռõʱ)
            }
        }
        break;

        case S_INIT_ASK_CSQ_R://ȴCSQӦ
        {
            if (NbiotCheckAtAck() == UART_OK)//ȷӦ
            {
                
                s_at_error_count = 0;
                
                s_init_state = S_INIT_AT_ECCESQS; 
                set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
            }
            else if ((!check_timer_1ms()) || (NbiotCheckAtAck() == UART_ERROR))
            {
                if (++s_at_error_count >= NUM_AT_CSQ_ERROR)
                {
                    
					s_at_error_count = 0;
					
					s_init_state = S_INIT_AT_ECCESQS; //ʼѯCEREG
					set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
                else
                {
                    s_init_state = S_INIT_ASK_CSQ;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME); 
                }
            }
        }
        break;
		
		case S_INIT_AT_ECCESQS://رźŸ±
        {
            if (!check_timer_1s())
            {
                NbiotUartSend((u8*) c_AT_ECCESQS, strlen(c_AT_ECCESQS), cst_AT_No_AT_ECCESQS);
                set_timer_1s(2);
                s_init_state = S_INIT_AT_ECCESQS_R;
            }
        }
        break;

        case S_INIT_AT_ECCESQS_R:
        {
            if (!check_timer_1s())
            {
                if (NbiotCheckAtAck() == UART_OK)
                {
                    //ȷӦ
					s_at_error_count = 0;
					set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                    s_init_state = S_INIT_AT_ECSTATUS;
                }
                else
                {
                    //شӦ߶ʱʱ䵽
                    s_at_error_count++;
                    if (s_at_error_count >= 2)
                    {
                        s_at_error_count = 0;
						set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                        s_init_state = S_INIT_AT_ECSTATUS;
                    }
                    else
                    {
                        s_init_state = S_INIT_AT_ECCESQS;
						set_timer_1s(1);
                    }
                }
            }
        }
        break;

		case S_INIT_AT_ECSTATUS://ѯźŵȹؼ
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*)c_AT_ECSTATUS, strlen((const char*) c_AT_ECSTATUS), cst_AT_No_AT_ECSTATUS);
                set_timer_1ms(4*AT_COMMAND_SEND_INTERVAL_TIME);//2s
                s_init_state = S_INIT_AT_ECSTATUS_R;
            }
        }
        break;

        case S_INIT_AT_ECSTATUS_R:
        {
            if (!check_timer_1ms())
            {
                if (NbiotCheckAtAck() == UART_OK)
                {
					 s_at_error_count = 0;
					s_init_state = S_INIT_ASK_CEREG; 
                }
                else
                {
                    //شӦ߶ʱʱ䵽
                    s_at_error_count++;
                    if (s_at_error_count >= 2)
                    {
						s_at_error_count = 0;
						s_init_state = S_INIT_ASK_CEREG; 
                    }
                    else
                    {
                        s_init_state = S_INIT_AT_ECSTATUS;
                    }
                }
            }
        }
        break;

        case S_INIT_ASK_CEREG://ʼѯCEREG
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_CEREG, strlen((const char*) c_AT_CEREG), cst_AT_No_AT_CEREG);
                s_init_state = S_INIT_ASK_CEREG_R;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME * 2); 
            }
        }
        break;

        case S_INIT_ASK_CEREG_R://ȴCEREGӦ
        {
            if (NbiotCheckAtAck() == UART_OK)//ȷӦ
            {
                s_at_error_count = 0;
                s_init_state = S_INIT_ASK_CGATT;
                set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
            }
            else if ((!check_timer_1ms()) || (NbiotCheckAtAck() == UART_ERROR))//Ӧʱ
            {
				u8 NB_login_ask_times = FrameCheckParaApp(FramePara_NbParaLoginAckTimes);
                if (NB_login_ask_times < 30)
                {
                    NB_login_ask_times = 30;
                }
                if (NB_login_ask_times > 150)
                {
                    NB_login_ask_times = 150;
                }
                if (++s_at_error_count >= NB_login_ask_times)
                {
                    s_at_error_count = 0;
					s_init_state = S_INIT_ASK_CGATT;
					set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
                else
                {
                    s_init_state = S_INIT_ASK_CEREG;
                    set_timer_1ms(2 * AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        }
        break;

        case S_INIT_ASK_CGATT://ʼѯCGATT
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_CGATT, strlen(c_AT_CGATT), cst_AT_No_AT_CGATT_how);
                s_init_state = S_INIT_ASK_CGATT_R;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME*2); //ԱATָصʱ300ms(ͺͽռõʱ)
            }
        }
        break;

        case S_INIT_ASK_CGATT_R://ȴCGATTӦ
        {
            if (NbiotCheckAtAck() == UART_OK)//ȷӦ
            {
                s_at_error_count = 0;
                g_s_nbiot_task_flag = TASK_SUCCESS; //ʼɹ
                s_init_state = S_INIT_POWER_ON; // ָ뷵
            }
            else if ((!check_timer_1ms()) || (NbiotCheckAtAck() == UART_ERROR))//Ӧʱ
            {
				if (++s_at_error_count >= NUM_AT_CGATT_ERROR)
                {
                    s_at_error_count = 0;
					*Nbiot_Send_Data.state = NBIOT_ERROR;
					g_s_nbiot_task_flag = TASK_FAIL; //Ϊֹɹ
                    s_init_state = S_INIT_POWER_ON;
                }
                else
                {
                    s_init_state = S_INIT_ASK_CGATT;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        }
        break;
        default:
        {
            s_at_error_count = 0;
			s_init_state = S_INIT_POWER_ON;
        }
        break;
    }
}
void NbiotInitMachine(void)
{
	NbiotInitMachine_E7025();
}
//
void CoapStartConnect(void)
{
	s_coap_connect_state = S_COAP_CONNECT_START;
}
/***************************************************************************
 * @fun_name     static void CoapConnectMachine()
 * @brief        Coap״̬
 ***************************************************************************/
void CoapConnectMachine_E7025(void)
{
    static u8 s_at_error_count = 0;
    unsigned char *nbiot_ip;
    u16 nbiot_port;
	static char c_AT_CTM2MSETPM[50] = "AT+CTM2MSETPM=\"117.060.157.137\",05683,86400\r"; //õIOTƽ̨Ӳ
	static const char* c_AT_CTM2MREG = "AT+CTM2MREG\r"; //עIOTƽ̨
	static const char* c_AT_CCLK = "AT+CCLK?\r"; //ѯվʱ
	
    switch (s_coap_connect_state)
    {
        case S_COAP_CONNECT_START:
        {
            s_at_error_count=0;
            s_coap_connect_state = S_AT_CTM2MSET; 
            set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
        } 
        break;

        case S_AT_CTM2MSET://õIOTƽ̨Ӳ
        {
            if (!check_timer_1ms())
            {
				u16 len = 15; //ATָĳȣݷͳȵλ
				nbiot_port = coap_port;
				nbiot_ip = coap_ip;
				
                //IP Ĵ洢Ȼʹˮԭʽ桰.ţʹʱ
				int i;
				for (i = 0; i < 4; i++)
				{
					if (nbiot_ip[i] < 10)
					{
						c_AT_CTM2MSETPM[len++] = nbiot_ip[i] + 0x30;
					}
					else if (nbiot_ip[i] < 100)
					{
						c_AT_CTM2MSETPM[len++] = (nbiot_ip[i] / 10) + 0x30;
						c_AT_CTM2MSETPM[len++] = (nbiot_ip[i] % 10) + 0x30;
					}
					else
					{
						c_AT_CTM2MSETPM[len++] = (nbiot_ip[i] / 100) + 0x30;
						c_AT_CTM2MSETPM[len++] = (nbiot_ip[i] / 10) % 10 + 0x30;
						c_AT_CTM2MSETPM[len++] = (nbiot_ip[i] % 10) + 0x30;
					}
					c_AT_CTM2MSETPM[len++] = '.';
				}
				len--; //ĵ
				
                c_AT_CTM2MSETPM[len++] = '\"';
                c_AT_CTM2MSETPM[len++] = ',';
                c_AT_CTM2MSETPM[len++] = ((nbiot_port) / 10000) + 0x30;
                c_AT_CTM2MSETPM[len++] = (((nbiot_port) % 10000) / 1000) + 0x30;
                c_AT_CTM2MSETPM[len++] = (((nbiot_port) % 1000) / 100) + 0x30;
                c_AT_CTM2MSETPM[len++] = (((nbiot_port) % 100) / 10) + 0x30;
                c_AT_CTM2MSETPM[len++] = ((nbiot_port) % 10) + 0x30;
				c_AT_CTM2MSETPM[len++] = ',';
				c_AT_CTM2MSETPM[len++] = '8';
				c_AT_CTM2MSETPM[len++] = '6';
				c_AT_CTM2MSETPM[len++] = '4';
				c_AT_CTM2MSETPM[len++] = '0';
				c_AT_CTM2MSETPM[len++] = '0';
                c_AT_CTM2MSETPM[len++] = '\r';
                NbiotUartSend((u8*)c_AT_CTM2MSETPM, len, cst_AT_No_AT_CTM2MSET);
                set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                s_coap_connect_state = S_AT_CTM2MSET_R;
            }
        }
        break;
		
		case S_AT_CTM2MSET_R:
		{
			if (NbiotCheckAtAck() == UART_OK)
            {
                s_at_error_count = 0;
                s_coap_connect_state = S_AT_CTM2MREG;
                set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
            }
            else if (!check_timer_1ms() || NbiotCheckAtAck() == UART_ERROR)
            {
                s_at_error_count++;
                if (s_at_error_count >= NUM_AT_CTM2MSET_ERROR)//
                {
					s_at_error_count = 0;
                    s_coap_connect_state = S_AT_CTM2MREG;
					set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
                else
                {
                    s_coap_connect_state = S_AT_CTM2MSET;
                }
            }
		}
		break;
		
		case S_AT_CTM2MREG://עIOTƽ̨
		{
			if(!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_CTM2MREG, strlen(c_AT_CTM2MREG), cst_AT_No_AT_CTM2MREG);
                set_timer_1s(8);
                s_coap_connect_state = S_AT_CTM2MREG_R;
            }
		}
		break;
		
		case S_AT_CTM2MREG_R:
		{
			if (NbiotCheckAtAck() == UART_OK)
            {
                s_at_error_count = 0;
                s_coap_connect_state = S_AT_COAP_CCLK;
                set_timer_1s(1);
            }
            else if (!check_timer_1s() || NbiotCheckAtAck() == UART_ERROR)
            {
                s_at_error_count++;
                if (s_at_error_count >= NUM_AT_CTM2MREG_ERROR)//
                {
					*Nbiot_Send_Data.state = NBIOT_ERROR;
					g_s_nbiot_task_flag = TASK_FAIL; //Ϊֹɹ
					s_at_error_count = 0;
					set_timer_1s(1);
					s_coap_connect_state = S_COAP_CONNECT_START; //״̬عʼ״̬
                }
                else
                {
					set_timer_1ms(8*AT_COMMAND_SEND_INTERVAL_TIME);
                    s_coap_connect_state = S_AT_CTM2MREG;
                }
            }
		}
		break;
		
	
		case S_AT_COAP_CCLK://ʼѯʱ
        {
            if (!check_timer_1s())
            {
                NbiotUartSend((u8*) c_AT_CCLK, strlen(c_AT_CCLK), cst_AT_No_AT_CCLK);
                s_coap_connect_state = S_AT_COAP_CCLK_R;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME); //ԱATָصʱ300ms(ͺͽռõʱ)
            }
        }
        break;

        case S_AT_COAP_CCLK_R://ȴӦ
        {
            if (NbiotCheckAtAck() == UART_OK)//ȷӦ
            {
				s_at_error_count = 0;
				*Nbiot_Send_Data.state = NBIOT_ONLINE;
				s_coap_connect_state = S_COAP_CONNECT_START; //״̬عʼ״̬
				g_s_nbiot_task_flag = TASK_SUCCESS; //Ϊֹɹ
            }
            else if ((!check_timer_1ms()) || (NbiotCheckAtAck() == UART_ERROR))//Ӧʱ
            {
                if (++s_at_error_count >= NUM_AT_CCLK_ERROR)
                {
					s_at_error_count = 0;
					*Nbiot_Send_Data.state = NBIOT_ONLINE;
					s_coap_connect_state = S_COAP_CONNECT_START; //״̬عʼ״̬
					g_s_nbiot_task_flag = TASK_SUCCESS; //Ϊֹɹ
                }
                else
                {
                    s_coap_connect_state = S_COAP_CCLK;
                    set_timer_1s(1);
                }
            }
        }
        break;

        default:
        {
            s_coap_connect_state = S_COAP_CONNECT_START; //״̬عʼ״̬
        }
        break;
    }
}
void CoapConnectMachine(void)
{
	CoapConnectMachine_E7025();
}
void StartNbiotSendData(void)
{
	if(g_s_nbiot_send_type == SEND_TYPE_COAP)
	{
		/*if(Nbiot_Para.Telecom == SIM_CARD_MOBILE)//ƶ
		{
			StartOnenetSendData();
		}
		else//ſ
		{
			StartCoapSendData(); //ݷ״̬
		}*/
		StartTcpSendData();
	}
	else if(g_s_nbiot_send_type == SEND_TYPE_UDP1)
	{
		StartUdpSendData(); //ݷ״̬
		UdpStartCheckData();//ѯUDP
	}
	else if(g_s_nbiot_send_type == SEND_TYPE_UDP2)
	{
		StartUdpSendData(); //ݷ״̬
		UdpStartCheckData();//ѯUDP
	}
}

#if SEND_ACKID_ENABLE
u16 Send_AckID = 0;
#endif


//
void StartCoapSendData(void)
{
	s_coap_send_state = S_SEND_START;
}

void CoapSendDataMachine_E7025(void)
{
    static u8 s_at_error_count = 0; //ATָۼƷʧܴ
    static const u8 temp_AT_Buffer[]= {"AT+CTM2MSEND="};
    switch (s_coap_send_state)
    {
        case S_SEND_START:
        {
            s_coap_send_state = S_SEND_DATA; //յݷͣģᱨERRORʱ1SERROR
            set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
        }
        break;

        case S_SEND_DATA:
        {
            if (!check_timer_1ms())
            {
                u16 len = 13;//8; //ATָĳȣݷͳȵλ
                int i;
                for(i=0; i<13; i++)
                {
                    c_AT_NMGS[i]=temp_AT_Buffer[i];
                }
                //
                for (i = 0; i < Nbiot_Send_Data.len; i++)
                {
                    if ((*(Nbiot_Send_Data.buf + i) >> 4) >= 0x0A)
                    {
                        c_AT_NMGS[len++] = (*(Nbiot_Send_Data.buf + i) >> 4) + 0x37;
                    }
                    else
                    {
                        c_AT_NMGS[len++] = (*(Nbiot_Send_Data.buf + i) >> 4) + 0x30;
                    }

                    if ((*(Nbiot_Send_Data.buf + i) & 0x0F) >= 0x0A)
                    {
                        c_AT_NMGS[len++] = (*(Nbiot_Send_Data.buf + i) & 0x0F) + 0x37;
                    }
                    else
                    {
                        c_AT_NMGS[len++] = (*(Nbiot_Send_Data.buf + i) & 0x0F) + 0x30;
                    }
                }
                c_AT_NMGS[len++] = '\r';
                NbiotUartSend((u8*) c_AT_NMGS, len, cst_AT_No_AT_NMGS);
                set_timer_1s(4);
                s_coap_send_state = S_SEND_DATA_R;
            }
        }
        break;

        case S_SEND_DATA_R:
        {
            if (NbiotCheckAtAck() == UART_OK) //ȷӦ
            {
                s_at_error_count = 0;
                g_s_nbiot_task_flag = TASK_SUCCESS;
                *Nbiot_Send_Data.state = NBIOT_SUCCESS;
                s_coap_send_state = S_SEND_START;
            }
            else if (NbiotCheckAtAck() == UART_ERROR || (!check_timer_1s()))
            {
                s_at_error_count++;
                if (s_at_error_count >= 2)
                {
                    s_at_error_count = 0;
                    *Nbiot_Send_Data.state = cst_AT_No_AT_NMGS;
                    g_s_nbiot_task_flag = TASK_FAIL;
                    s_coap_send_state = S_SEND_START;
                }
                else
                {
                    s_coap_send_state = S_SEND_DATA_R;
                }
            }
        }
        break;

        default:
        {
            s_coap_send_state = S_SEND_START;
        }
        break;
    }
}
void CoapSendDataMachine(void)
{
	CoapSendDataMachine_E7025();
}
//UDP
void UdpStartConnect(u8 udp_num)
{
	nbiot_temp_connect_type = udp_num;
	s_udp_connect_state = S_UDP_CONNECT_START;
}
/***************************************************************************
 * @fun_name     void UdpConnectMachine(void)
 * @brief        UDP״̬
 ***************************************************************************/
void UdpConnectMachine_E7025(void)
{
    static u8 s_at_error_count = 0;

    static char c_AT_QIOPEN[100];  
	
    switch (s_udp_connect_state)
    {
        case S_UDP_CONNECT_START: //ʼ
        {
            s_at_error_count=0;
            s_udp_connect_state = S_UDP_QIOPEN;
            set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
        }
        break;

        case S_UDP_QIOPEN:
        {
            if (!check_timer_1ms())
            {
				u16 len = 21; //ATָĳȣݷͳȵλ
				char strings_temp[50];
				memset(c_AT_QIOPEN,0,sizeof(c_AT_QIOPEN));
				memset(strings_temp,0,sizeof(strings_temp));
				strcpy(c_AT_QIOPEN,"AT+ECSOCR=DGRAM,17,1234,1,AF_INET\r"); //UDP
				len = strlen(c_AT_QIOPEN);              
				NbiotUartSend((u8*)c_AT_QIOPEN, len, cst_AT_No_AT_QIOPEN);
				set_timer_1s(2);
				s_udp_connect_state = S_UDP_QIOPEN_R;
            }
        }
        break;

        case S_UDP_QIOPEN_R:
        {
            if (NbiotCheckAtAck() == UART_OK)
            {
				s_at_error_count = 0;                
				s_udp_connect_state = S_UDP_Wait;
				set_timer_1s(1);
            }
            else if (!check_timer_1s() || NbiotCheckAtAck() == UART_ERROR)
            {
                s_at_error_count++;
                if (s_at_error_count >= AT_ERROR)//
                {
					s_at_error_count = 0;
					s_udp_connect_state = S_UDP_Wait;
					set_timer_1s(1);
                }
                else
                {
                    s_udp_connect_state = S_UDP_QIOPEN;
                }
            }
        }
        break;

        case S_UDP_Wait:
        {
            if((!check_timer_1s()))
            {
                s_at_error_count = 0;
                *Nbiot_Send_Data.state = NBIOT_ONLINE;
                s_udp_connect_state = S_UDP_CONNECT_START; //״̬عʼ״̬
                g_s_nbiot_task_flag = TASK_SUCCESS; //Ϊֹɹ
            }
        }
        break;

        default:
        {
            s_udp_connect_state = S_UDP_CONNECT_START; //״̬عʼ״̬
        }
        break;
    }
}
void UdpConnectMachine(void)
{
	UdpConnectMachine_E7025();
}

//TdpConnectMachine

//ģATָ
typedef enum{
	S_TCP_CONNECT_START=0, 
	S_TCP_QIOPEN,
	S_TCP_QIOPEN_R,
	S_TCP_NCDP_CK,
	S_TCP_NCDP_CK_R,
	S_TCP_SUCCESS,
	S_TCP_FAIL
}TYP_AT_CMDCODE;

const char tcp_socket_buf[6]={'0','1','2','3','4','5'};
u8 tcp_socket_index=0;
TYP_AT_CMDCODE s_tcp_connect_state=S_TCP_CONNECT_START;
static char stringbuffer_temp[256];

void TcpStartConnect(void)
{
	s_tcp_connect_state = S_TCP_CONNECT_START;
}
void TcpConnectMachine(void)
{
	unsigned char *nbiot_ip;
    u16 nbiot_port;
    static u8 s_at_error_count = 0;
	//static const u8 temp_AT_Buffer[34]= {"AT+ECSOCR=DGRAM,17,1234,1,AF_INET\r"};
	static const u8 temp_AT_Buffer[34]= {"AT+ECSOCR=STREAM,6,1234,1,AF_INET\r"};//TCP
    static char c_AT_QIOPEN[50];  
	
    switch (s_tcp_connect_state)
    {
        case S_TCP_CONNECT_START: //ʼ
        {
            s_at_error_count=0;
            s_tcp_connect_state = S_TCP_QIOPEN;
			tcp_socket_index = 0;
            set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
        }
        break;

        case S_TCP_QIOPEN://׽
        {
			if(TASK_IDLE == UartIfIdle(NB_UART_COM))
			{
				if (!check_timer_1ms())
				{
					u16 len = 0; //ATָĳȣݷͳȵλ
					int i;
					for(i=0; i<34; i++)
					{
						c_AT_QIOPEN[i]=temp_AT_Buffer[i];
					}
					if(tcp_socket_index>4)
					{
						tcp_socket_index = 0;
					}
					c_AT_QIOPEN[22] = tcp_socket_buf[tcp_socket_index];//socket
					
					len = 34;          
					NbiotUartSend((u8*)c_AT_QIOPEN, len, cst_AT_No_AT_QIOPEN);
					set_timer_1s(5);
					s_tcp_connect_state = S_TCP_QIOPEN_R;
				}
			}
        }
        break;

        case S_TCP_QIOPEN_R:
        {
            if (NbiotCheckAtAck() == UART_OK)
            {
				s_at_error_count = 0;                
				s_tcp_connect_state = S_TCP_NCDP_CK;
				set_timer_1s(1);
            }
            else if (!check_timer_1s() || NbiotCheckAtAck() == UART_ERROR)
            {
                s_at_error_count++;
                if (s_at_error_count >= 3)
                {
					s_at_error_count = 0;
					s_tcp_connect_state = S_TCP_FAIL;
					set_timer_1s(1);
                }
                else
                {
                    s_tcp_connect_state = S_TCP_QIOPEN;
                }
            }
        }
        break;
		case S_TCP_NCDP_CK://ӷ
		{	
			if(TASK_IDLE == UartIfIdle(NB_UART_COM))
			{
				if (!check_timer_1s())
				{
					int ip_len = 0; 
					nbiot_port = coap_port;
					nbiot_ip = coap_ip;
					memset(stringbuffer_temp,0,sizeof(stringbuffer_temp));
					//"AT+ECSOCO=1,"183.230.174.137",6065"
					//IP Ĵ洢Ȼʹˮԭʽ桰.ţʹʱ
					stringbuffer_temp[ip_len++]='A';
					stringbuffer_temp[ip_len++]='T';
					stringbuffer_temp[ip_len++]='+';
					stringbuffer_temp[ip_len++]='E';
					stringbuffer_temp[ip_len++]='C';
					stringbuffer_temp[ip_len++]='S';
					stringbuffer_temp[ip_len++]='O';
					stringbuffer_temp[ip_len++]='C';
					stringbuffer_temp[ip_len++]='O';
					stringbuffer_temp[ip_len++]='=';
					stringbuffer_temp[ip_len++]=NbiotGetE7025TcpSocket();
					stringbuffer_temp[ip_len++]=',';
					stringbuffer_temp[ip_len++]='"';
					
					for (int i = 0; i < 4; i++)
					{
						if (nbiot_ip[i] < 10)
						{
							stringbuffer_temp[ip_len++] = nbiot_ip[i] + 0x30;
						}
						else if (nbiot_ip[i] < 100)
						{
							stringbuffer_temp[ip_len++] = (nbiot_ip[i] / 10) + 0x30;
							stringbuffer_temp[ip_len++] = (nbiot_ip[i] % 10) + 0x30;
						}
						else
						{
							stringbuffer_temp[ip_len++] = (nbiot_ip[i] / 100) + 0x30;
							stringbuffer_temp[ip_len++] = (nbiot_ip[i] / 10) % 10 + 0x30;
							stringbuffer_temp[ip_len++] = (nbiot_ip[i] % 10) + 0x30;
						}
						stringbuffer_temp[ip_len++] = '.';
					}
					ip_len--; //ĵ
					stringbuffer_temp[ip_len++] = '\"';
					stringbuffer_temp[ip_len++] = ',';
					stringbuffer_temp[ip_len++] = ((nbiot_port) / 10000) + 0x30;
					stringbuffer_temp[ip_len++] = (((nbiot_port) % 10000) / 1000) + 0x30;
					stringbuffer_temp[ip_len++] = (((nbiot_port) % 1000) / 100) + 0x30;
					stringbuffer_temp[ip_len++] = (((nbiot_port) % 100) / 10) + 0x30;
					stringbuffer_temp[ip_len++] = ((nbiot_port) % 10) + 0x30;
					stringbuffer_temp[ip_len++] = '\r';
					
					NbiotUartSend((u8*)stringbuffer_temp, ip_len, cst_AT_No_AT);
					set_timer_1s(10);
					s_tcp_connect_state = S_TCP_NCDP_CK_R;
				}
			}
		}
		break;
		
		case S_TCP_NCDP_CK_R:
		{
			if (NbiotCheckAtAck() == UART_OK)
            {
				s_at_error_count = 0;                
				s_tcp_connect_state = S_TCP_SUCCESS;
				set_timer_1s(1);
            }
            else if (!check_timer_1s() || NbiotCheckAtAck() == UART_ERROR)
            {
                s_at_error_count++;
                if (s_at_error_count >= 5)//
                {
					s_at_error_count = 0;
					s_tcp_connect_state = S_TCP_FAIL;
					set_timer_1s(1);
                }
                else
                {
                    s_tcp_connect_state = S_TCP_NCDP_CK;
                }
            }
		}
		break;
		
        case S_TCP_SUCCESS:
        {
            if((!check_timer_1s()))
            {
                s_at_error_count = 0;
                s_tcp_connect_state = S_TCP_CONNECT_START; //״̬عʼ״̬
                g_s_nbiot_task_flag = TASK_SUCCESS; //Ϊֹɹ
            }
        }
        break;
		
		case S_TCP_FAIL:
        {
            if((!check_timer_1s()))
            {
                s_at_error_count = 0;
                s_tcp_connect_state = S_TCP_CONNECT_START; //״̬عʼ״̬
                g_s_nbiot_task_flag = TASK_FAIL; //Ϊֹɹ
            }
        }
        break;

        default:
        {
            s_tcp_connect_state = S_TCP_CONNECT_START; //״̬عʼ״̬
        }
        break;
    }
}
//
void StartUdpSendData(void)
{
	s_udp_send_state = S_SEND_START;
}
//AT+ECSOST=1,"183.230.174.137",6065,2,"3334"
void UdpSendDataMachine_E7025(void)
{
	unsigned char *nbiot_ip;
    u16 nbiot_port;	
    static u8 s_at_error_count = 0; //ATָۼƷʧܴ
	static const u8 temp_AT_Buffer[10]= {"AT+ECSOST="};
    switch (s_udp_send_state)
    {
        case S_SEND_START:
        {
            s_udp_send_state = S_SEND_DATA; //յݷͣģᱨERRORʱ1SERROR
            set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
        }
        break;

        case S_SEND_DATA:
        {
            if (!check_timer_1ms())
            {
				u16 len = 0; //ATָĳȣݷͳȵλ
				nbiot_port = udp_port1;
				nbiot_ip = udp_ip1;
				int i;	
				for(i=0;i<10;i++)
				{
					c_AT_NMGS[len++] = temp_AT_Buffer[i];
				}
				//socekt
				c_AT_NMGS[len++] = NbiotGetE7025UdpSocket();//socketΧΪ0~6
				c_AT_NMGS[len++] = ',';
				c_AT_NMGS[len++] = '\"';
				//IP: NSOST Udpʹ
				for (i = 0; i < 4; i++)
				{
					if (nbiot_ip[i] < 10)
					{
						c_AT_NMGS[len++] = nbiot_ip[i] + 0x30;
					}
					else if (nbiot_ip[i] < 100)
					{
						c_AT_NMGS[len++] = (nbiot_ip[i] / 10) + 0x30;
						c_AT_NMGS[len++] = (nbiot_ip[i] % 10) + 0x30;
					}
					else
					{
						c_AT_NMGS[len++] = (nbiot_ip[i] / 100) + 0x30;
						c_AT_NMGS[len++] = (nbiot_ip[i] / 10) % 10 + 0x30;
						c_AT_NMGS[len++] = (nbiot_ip[i] % 10) + 0x30;
					}
					c_AT_NMGS[len++] = '.';
				}
				//˿ں
				len--; //ĵ 
				c_AT_NMGS[len++] = '\"';
				c_AT_NMGS[len++] = ',';
				c_AT_NMGS[len++] = (nbiot_port / 10000) + 0x30;
				c_AT_NMGS[len++] = (nbiot_port % 10000) / 1000 + 0x30;
				c_AT_NMGS[len++] = (nbiot_port % 1000) / 100 + 0x30;
				c_AT_NMGS[len++] = (nbiot_port % 100) / 10 + 0x30;
				c_AT_NMGS[len++] = (nbiot_port % 10) + 0x30;
				c_AT_NMGS[len++] = ',';
				//
				c_AT_NMGS[len++] = (Nbiot_Send_Data.len / 10000) + 0x30;
				c_AT_NMGS[len++] = (Nbiot_Send_Data.len % 10000) / 1000 + 0x30;
				c_AT_NMGS[len++] = (Nbiot_Send_Data.len % 1000) / 100 + 0x30;
				c_AT_NMGS[len++] = (Nbiot_Send_Data.len % 100) / 10 + 0x30;
				c_AT_NMGS[len++] = (Nbiot_Send_Data.len % 10) + 0x30;
				c_AT_NMGS[len++] = ',';
				//
				for (i = 0; i < Nbiot_Send_Data.len; i++)
				{
					if ((*(Nbiot_Send_Data.buf + i) >> 4) >= 0x0A)
					{
						c_AT_NMGS[len++] = (*(Nbiot_Send_Data.buf + i) >> 4) + 0x37;
					}
					else
					{
						c_AT_NMGS[len++] = (*(Nbiot_Send_Data.buf + i) >> 4) + 0x30;
					}

					if ((*(Nbiot_Send_Data.buf + i) & 0x0F) >= 0x0A)
					{
						c_AT_NMGS[len++] = (*(Nbiot_Send_Data.buf + i) & 0x0F) + 0x37;
					}
					else
					{
						c_AT_NMGS[len++] = (*(Nbiot_Send_Data.buf + i) & 0x0F) + 0x30;
					}
				}
				c_AT_NMGS[len++] = '\r';
                NbiotUartSend((u8*) c_AT_NMGS, len, cst_AT_No_AT_NMGS);
                set_timer_1s(4);
                s_udp_send_state = S_SEND_DATA_R;
            }
        }
        break;

        case S_SEND_DATA_R:
        {
            if (NbiotCheckAtAck() == UART_OK) //ȷӦ
            {
                s_at_error_count = 0;
                g_s_nbiot_task_flag = TASK_SUCCESS;
                *Nbiot_Send_Data.state = NBIOT_SUCCESS;
                s_udp_send_state = S_SEND_START;
            }
            else if (NbiotCheckAtAck() == UART_ERROR || (!check_timer_1s()))
            {
                s_at_error_count++;
                if (s_at_error_count >= 2)
                {
                    s_at_error_count = 0;
                    *Nbiot_Send_Data.state = cst_AT_No_AT_NMGS;
                    g_s_nbiot_task_flag = TASK_SUCCESS;
                    s_udp_send_state = S_SEND_START;
                }
                else
                {
					set_timer_1s(4);
                    s_udp_send_state = S_SEND_DATA;
                }
            }
        }
        break;

        default:
        {
            s_udp_send_state = S_SEND_START;
        }
        break;
    }
}
void UdpSendDataMachine(void)
{
	UdpSendDataMachine_E7025();
}

u8 s_tcp_send_state=S_SEND_START;
void StartTcpSendData(void)
{
	s_tcp_send_state = S_SEND_START;
}
//AT+ECSOST=1,"183.230.174.137",6065,2,"3334"
//AT+ECSOSD=1,2,"3132"
void TcpSendDataMachine(void)
{
    static u8 s_at_error_count = 0; //ATָۼƷʧܴ
	static const u8 temp_AT_Buffer[10]= {"AT+ECSOSD="};
    switch (s_tcp_send_state)
    {
        case S_SEND_START:
        {
            s_tcp_send_state = S_SEND_DATA; //յݷͣģᱨERRORʱ1SERROR
            set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
        }
        break;

        case S_SEND_DATA:
        {
            if (!check_timer_1ms())
            {
				u16 len = 0; //ATָĳȣݷͳȵλ
				for(int i=0;i<10;i++)
				{
					c_AT_NMGS[len++] = temp_AT_Buffer[i];
				}
				//socekt
				c_AT_NMGS[len++] = NbiotGetE7025TcpSocket();//socketΧΪ0~6
				c_AT_NMGS[len++] = ',';
				//
				c_AT_NMGS[len++] = (Nbiot_Send_Data.len / 10000) + 0x30;
				c_AT_NMGS[len++] = (Nbiot_Send_Data.len % 10000) / 1000 + 0x30;
				c_AT_NMGS[len++] = (Nbiot_Send_Data.len % 1000) / 100 + 0x30;
				c_AT_NMGS[len++] = (Nbiot_Send_Data.len % 100) / 10 + 0x30;
				c_AT_NMGS[len++] = (Nbiot_Send_Data.len % 10) + 0x30;
				c_AT_NMGS[len++] = ',';
				c_AT_NMGS[len++] = '\"';
				//
				for (int i = 0; i < Nbiot_Send_Data.len; i++)
				{
					if ((*(Nbiot_Send_Data.buf + i) >> 4) >= 0x0A)
					{
						c_AT_NMGS[len++] = (*(Nbiot_Send_Data.buf + i) >> 4) + 0x37;
					}
					else
					{
						c_AT_NMGS[len++] = (*(Nbiot_Send_Data.buf + i) >> 4) + 0x30;
					}

					if ((*(Nbiot_Send_Data.buf + i) & 0x0F) >= 0x0A)
					{
						c_AT_NMGS[len++] = (*(Nbiot_Send_Data.buf + i) & 0x0F) + 0x37;
					}
					else
					{
						c_AT_NMGS[len++] = (*(Nbiot_Send_Data.buf + i) & 0x0F) + 0x30;
					}
				}
				c_AT_NMGS[len++] = '\"';
				c_AT_NMGS[len++] = '\r';
                NbiotUartSend((u8*) c_AT_NMGS, len, cst_AT_No_AT_NMGS);
                set_timer_1s(4);
                s_tcp_send_state = S_SEND_DATA_R;
            }
        }
        break;

        case S_SEND_DATA_R:
        {
            if (NbiotCheckAtAck() == UART_OK) //ȷӦ
            {
                s_at_error_count = 0;
                g_s_nbiot_task_flag = TASK_SUCCESS;
                *Nbiot_Send_Data.state = NBIOT_SUCCESS;
                s_tcp_send_state = S_SEND_START;
            }
            else if (NbiotCheckAtAck() == UART_ERROR || (!check_timer_1s()))
            {
                s_at_error_count++;
                if (s_at_error_count >= 2)
                {
                    s_at_error_count = 0;
                    *Nbiot_Send_Data.state = cst_AT_No_AT_NMGS;
                    g_s_nbiot_task_flag = TASK_SUCCESS;
                    s_tcp_send_state = S_SEND_START;
                }
                else
                {
					set_timer_1s(4);
                    s_tcp_send_state = S_SEND_DATA;
                }
            }
        }
        break;

        default:
        {
            s_tcp_send_state = S_SEND_START;
        }
        break;
    }
}

void UdpReadDataMachine_E7025(void)
{
    static u8 s_error_count; //ATָۼƷʧܴ
    static u8 s_read_upd_data_state = S_START;
	static const u8 temp_AT_Buffer[16]= {"AT+ECSORF=2,512\r"};
    switch (s_read_upd_data_state)
    {
        case S_START:
        {
            set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
            s_error_count = 0;
            s_read_upd_data_state = S_AT_QIRD;
        }
        break;

        case S_AT_QIRD:
        {
            if (!check_timer_1ms())
            {
				u16 len=0;
				int i;	
				for(i=0;i<16;i++)
				{
					c_AT_NMGS[len++] = temp_AT_Buffer[i];
				}
				c_AT_NMGS[10] = NbiotGetE7025UdpSocket();//socketΧΪ0~6
                 NbiotUartSend((u8*) c_AT_NMGS, len, cst_AT_No_AT_UPD_READ);
                set_timer_1ms(3*AT_COMMAND_RECEIVE_WAIT_TIME);
                s_read_upd_data_state = S_AT_QIRD_R;
            }
        }
        break;

        case S_AT_QIRD_R:
        {
			if (NbiotCheckAtAck() == UART_OK)
			{
				//ȷӦ
				*Nbiot_Send_Data.state = QIRD_SUCCESS;
				g_s_nbiot_task_flag = TASK_SUCCESS;
				s_read_upd_data_state = S_START;
			}
			else if (!check_timer_1ms())
			{
				//شӦ߶ʱʱ䵽
				s_error_count++;
				if (s_error_count >= 3)
				{
					s_error_count = 0;
					*Nbiot_Send_Data.state = QIRD_ERROR;
					g_s_nbiot_task_flag = TASK_FAIL;
					s_read_upd_data_state = S_START;
				}
				else
				{
					set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
					s_read_upd_data_state = S_AT_QIRD;
				}
			}            
        }
        break;

        default:
        {
            s_read_upd_data_state = S_START;
        }
        break;
    }	
}
void UdpReadDataMachine(void)
{
   UdpReadDataMachine_E7025();
}
//
//OnenetConnectMachine
u8 s_onenet_connect_state=0;
void OneNetStartConnect(void)
{
	s_onenet_connect_state = S_ONENET_CONNECT_START;
}
/***************************************************************************
 * @fun_name     static void CoapConnectMachine()
 * @brief        Coap״̬
 ***************************************************************************/
void OnenetConnectMachine(void)
{
    static u8 s_at_error_count = 0;
    unsigned char *nbiot_ip;
    u16 nbiot_port;
	static char c_AT_MIPLCONFIG[40]="AT+MIPLCONFIG=0,183.230.040.040,05683\r";
	//static const char* c_AT_MIPLCONFIG_3 = "AT+MIPLCONFIG=3,0\r";
	static const char* c_AT_MIPLCONFIG_CK="AT+MIPLCONFIG?\r";//+MIPLCONFIG: 0,183.230.40.40,5683 +MIPLCONFIG: 2,2 +MIPLCONFIG: 3,1 +MIPLCONFIG: 4,0,1
	static const char* c_AT_MIPLCREATE="AT+MIPLCREATE\r";
	static const char* c_AT_MIPLADDOBJ = "AT+MIPLADDOBJ=0,3200,1,\"1\",4,2\r";
	static const char* c_AT_MIPLOPEN ="AT+MIPLOPEN=0,600,60\r";
    static const char* c_AT_CCLK = "AT+CCLK?\r"; //ѯվʱ
	static char c_AT_MIPLRSP_BUF[40];// AT+MIPLDISCOVERRSP=0,48839,1,4,"5750"
    switch (s_onenet_connect_state)
    {
		case S_ONENET_CONNECT_IDLE:
		{
		    break;
		}
        case S_ONENET_CONNECT_START: //ʼ
        {
            s_at_error_count=0;
            s_onenet_connect_state = S_ONENET_MIPLCONFIG;
            set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
        }
        break;

        case S_ONENET_MIPLCONFIG:
        {
            if (!check_timer_1ms())
            {
				u16 len = 16; //ATָĳȣݷͳȵλ
				nbiot_port = coap_port;
				nbiot_ip = coap_ip;

				//IP Ĵ洢Ȼʹˮԭʽ桰.ţʹʱ
				int i;
				for (i = 0; i < 4; i++)
				{
					if (nbiot_ip[i] < 10)
					{
						c_AT_MIPLCONFIG[len++] = nbiot_ip[i] + 0x30;
					}
					else if (nbiot_ip[i] < 100)
					{
						c_AT_MIPLCONFIG[len++] = (nbiot_ip[i] / 10) + 0x30;
						c_AT_MIPLCONFIG[len++] = (nbiot_ip[i] % 10) + 0x30;
					}
					else
					{
						c_AT_MIPLCONFIG[len++] = (nbiot_ip[i] / 100) + 0x30;
						c_AT_MIPLCONFIG[len++] = (nbiot_ip[i] / 10) % 10 + 0x30;
						c_AT_MIPLCONFIG[len++] = (nbiot_ip[i] % 10) + 0x30;
					}
					c_AT_MIPLCONFIG[len++] = '.';
				}
				len--; //ĵ
				c_AT_MIPLCONFIG[len++] = ',';
				//c_AT_MIPLCONFIG[len++] = ((nbiot_port) / 10000) + 0x30;
				c_AT_MIPLCONFIG[len++] = (((nbiot_port) % 10000) / 1000) + 0x30;
				c_AT_MIPLCONFIG[len++] = (((nbiot_port) % 1000) / 100) + 0x30;
				c_AT_MIPLCONFIG[len++] = (((nbiot_port) % 100) / 10) + 0x30;
				c_AT_MIPLCONFIG[len++] = ((nbiot_port) % 10) + 0x30;
				c_AT_MIPLCONFIG[len++] = '\r';
				NbiotUartSend((u8*)c_AT_MIPLCONFIG, len, cst_AT_No_AT_MIPLCONFIG);
				set_timer_1s(2);
				s_onenet_connect_state = S_ONENET_MIPLCONFIG_R;
            }
        }
        break;
		
		case S_ONENET_MIPLCONFIG_R:
        {
            if (NbiotCheckAtAck() == UART_OK)
            {
                s_at_error_count = 0;
                s_onenet_connect_state = S_ONENET_MIPLCONFIG_CK;//S_ONENET_MIPLCONFIG3;
                set_timer_1s(2);
            }
            else if (!check_timer_1s() || NbiotCheckAtAck() == UART_ERROR)
            {
                s_at_error_count++;
                if (s_at_error_count >= AT_ERROR)//
                {
					//һ㲻ᷢ,϶ܲ鵽ؽ
					s_at_error_count = 0;
					s_onenet_connect_state = S_ONENET_MIPLCONFIG_CK;//S_ONENET_MIPLCONFIG3;
					set_timer_1s(2);
                }
                else
                {
                    s_onenet_connect_state = S_ONENET_MIPLCONFIG;
                }
            }
        }
        break;

        case S_ONENET_MIPLCONFIG_CK:
        {
			 if (!check_timer_1s())
			 {
				 if(TASK_IDLE == UartIfIdle(NB_UART_COM))
				 {
				 	NbiotUartSend((u8*)c_AT_MIPLCONFIG_CK, strlen(c_AT_MIPLCONFIG_CK), cst_AT_No_AT_MIPLCONFIG_CK);
					s_onenet_connect_state = S_ONENET_MIPLCONFIG_CK_R;
					set_timer_1s(2);
				 }
			 }
        }
        break;
		
		case S_ONENET_MIPLCONFIG_CK_R:
        {
            if (NbiotCheckAtAck() == UART_OK)
            {
                s_at_error_count = 0;
                s_onenet_connect_state = S_ONENET_MIPLCREATE;
                set_timer_1s(2);
            }
            else if (!check_timer_1s())
            {
                s_at_error_count++;
                if (s_at_error_count >= NUM_AT_MIPLCONF_ERROR)//
                {
					//һ㲻ᷢ,϶ܲ鵽ؽ
					s_at_error_count = 0;
					s_onenet_connect_state = S_ONENET_MIPLCREATE;
					set_timer_1s(2);
                }
                else
                {
                    s_onenet_connect_state = S_ONENET_MIPLCONFIG_CK;
                }
            }
        }
        break;

        case S_ONENET_MIPLCREATE:
        {
            if(!check_timer_1s())
            {
				if(TASK_IDLE == UartIfIdle(NB_UART_COM))
				{
					NbiotUartSend((u8*) c_AT_MIPLCREATE, strlen(c_AT_MIPLCREATE), cst_AT_No_AT_MIPLCREATE);
					set_timer_1s(2);
					s_onenet_connect_state = S_ONENET_MIPLCREATE_R;		
				}
            }
        }
        break;

        case S_ONENET_MIPLCREATE_R:
        {
            if(NbiotCheckAtAck() == UART_OK)
            {
                s_at_error_count = 0;
                s_onenet_connect_state = S_ONENET_MIPLADDOBJ;
                set_timer_1s(2);
            }
            else if(!check_timer_1s())
            {
                s_at_error_count++;
                if (s_at_error_count >= NUM_AT_MIPLCREATE_ERROR)
                {
					s_at_error_count = 0;
					s_onenet_connect_state = S_ONENET_MIPLADDOBJ;
					set_timer_1s(2);
                }
                else
                {
                    s_onenet_connect_state = S_ONENET_MIPLCREATE;
                    set_timer_1s(2);
                }
            }
        }
        break;
		
		case S_ONENET_MIPLADDOBJ:
        {
            if(!check_timer_1s())
            {
				if(TASK_IDLE == UartIfIdle(NB_UART_COM))
				{
					NbiotUartSend((u8*) c_AT_MIPLADDOBJ, strlen(c_AT_MIPLADDOBJ), cst_AT_No_AT_MIPLADDOBJ);
					set_timer_1s(2);
					s_onenet_connect_state = S_ONENET_MIPLADDOBJ_R;
				}
            }
        }
        break;

        case S_ONENET_MIPLADDOBJ_R:
        {
            if (NbiotCheckAtAck() == UART_OK)
            {
                s_at_error_count	= 0;
                s_onenet_connect_state = S_ONENET_MIPLOPEN;
                set_timer_1s(2);
            }
            else if ((!check_timer_1s()))
            {
                s_at_error_count++;

                if (s_at_error_count >= NUM_AT_MIPLADDOBJ_ERROR)
                {
                    s_at_error_count	= 0;
                    s_onenet_connect_state = S_ONENET_MIPLOPEN;
                    set_timer_1s(2);
                }
                else
                {
                    s_onenet_connect_state = S_ONENET_MIPLADDOBJ;
                    set_timer_1s(1);
                }
            }
        }
        break;
	
        case S_ONENET_MIPLOPEN:
        {
            if (!check_timer_1s())
            {
                NbiotUartSend((u8 *) c_AT_MIPLOPEN, strlen(c_AT_MIPLOPEN), cst_AT_No_AT_MIPLOPEN);
                set_timer_1s(10);
                s_onenet_connect_state = S_ONENET_MIPLOPEN_R;
            }
        }
        break;
		
        case S_ONENET_MIPLOPEN_R:
        {
            if (NbiotCheckAtAck() == UART_OK)
            {
                s_at_error_count	= 0;
				NbiotClearAtAck();
				NbiotSetRevMiplobserve();
				set_timer_1s(10);
                s_onenet_connect_state = S_ONENET_MIPLOBSERVE;
            }
 
            else if ((!check_timer_1s()))
            {
                s_at_error_count++;

                if (s_at_error_count >= NUM_AT_MIPLOPEN_ERROR)
                {
					*Nbiot_Send_Data.state = NBIOT_ERROR;
					g_s_nbiot_task_flag = TASK_FAIL; //Ϊֹɹ
                    s_at_error_count	= 0;
                    s_onenet_connect_state = S_ONENET_MIPLOBSERVE;
                }
                else
                {
                    s_onenet_connect_state = S_ONENET_MIPLOPEN;
                    set_timer_1s(1);
                }
            }
        }
        break;

        case S_ONENET_MIPLOBSERVE: //static char c_AT_MIPLDISCOVERRSP[30];// AT+MIPLDISCOVERRSP=0,48839,1,4,"5750"
        {
			if ((NbiotCheckAtAck() == UART_OK)||(!check_timer_1s()))
			{
				u8	len;
				char  observe_num[10];
				memset(observe_num, 0, sizeof(observe_num));
				memset(c_AT_MIPLRSP_BUF, 0, sizeof(c_AT_MIPLRSP_BUF));
				strcpy(c_AT_MIPLRSP_BUF, "AT+MIPLOBSERVERSP=0,");

				NbiotGetObserve_num(observe_num);
				strcat(c_AT_MIPLRSP_BUF, observe_num);
				strcat(c_AT_MIPLRSP_BUF, ",1\r");

				len = strlen(c_AT_MIPLRSP_BUF);
				NbiotUartSend((u8 *) c_AT_MIPLRSP_BUF, len, cst_AT_No_AT);
				set_timer_1s(2);

				s_onenet_connect_state = S_ONENET_MIPLOBSERVE_R;
			}
        }
        break;

        case S_ONENET_MIPLOBSERVE_R: //Ӧյ--ȴӦ
        {
            if (NbiotCheckAtAck() == UART_OK)
            {
                s_at_error_count	= 0;
				NbiotClearAtAck();
				NbiotSetRevMipldiscover(); 
				set_timer_1s(5);
                s_onenet_connect_state = S_ONENET_MIPLDISCOVER;
            }
            else if ((!check_timer_1s()))
            {
                s_at_error_count++;
                if (s_at_error_count >= NUM_AT_MIPLOBSERVERSP_ERROR)
                {
                    *Nbiot_Send_Data.state = NBIOT_ERROR;
					g_s_nbiot_task_flag = TASK_FAIL; //Ϊֹɹ
                    set_timer_1s(1);
                    s_at_error_count	= 0;
                    s_onenet_connect_state = S_ONENET_CONNECT_IDLE;
                }
                else
                {    
					set_timer_1s(5);					
                    s_onenet_connect_state = S_ONENET_MIPLOBSERVE;
                }
            }
        }
        break;

        case S_ONENET_MIPLDISCOVER: 
        {
			if ((NbiotCheckAtAck() == UART_OK)||(!check_timer_1s()))	
            {
				u8	len;
				char discover_num[10];
				memset(discover_num, 0, sizeof(discover_num));
                memset(c_AT_MIPLRSP_BUF, 0, sizeof(c_AT_MIPLRSP_BUF));
                strcpy(c_AT_MIPLRSP_BUF, "AT+MIPLDISCOVERRSP=0,");

                NbiotGetDiscover_num(discover_num);
                strcat(c_AT_MIPLRSP_BUF, discover_num);
                strcat(c_AT_MIPLRSP_BUF, ",1,4,\"5750\"\r");

                len = strlen(c_AT_MIPLRSP_BUF);
                NbiotUartSend((u8 *) c_AT_MIPLRSP_BUF, len, cst_AT_No_AT);
				set_timer_1s(5);
                s_onenet_connect_state = S_ONENET_MIPLDISCOVER_R;
            }
        }
        break;

        case S_ONENET_MIPLDISCOVER_R: //Ӧյ--ȴӦ
        {
            if (NbiotCheckAtAck() == UART_OK)
            {
                set_timer_1s(1);
                s_at_error_count	= 0;
                s_onenet_connect_state = S_ONENET_CCLK;
            }
            else if ((!check_timer_1s()))
            {
                s_at_error_count++;

                if (s_at_error_count >= NUM_AT_MIPLDISCOVERRSP_ERROR)
                {
					*Nbiot_Send_Data.state = NBIOT_ERROR;
					g_s_nbiot_task_flag = TASK_FAIL; //Ϊֹɹ
                    set_timer_1s(1);
                    s_at_error_count	= 0;
                    s_onenet_connect_state = S_ONENET_CONNECT_IDLE;
                }
                else
                {
                    NbiotSetRevMipldiscover(); 
                    s_onenet_connect_state = S_ONENET_MIPLDISCOVER;
                    set_timer_1s(5);
                }
            }
        }
        break;		
		
		case S_ONENET_CCLK://ʼѯʱ
        {
            if (!check_timer_1s())
            {
                NbiotUartSend((u8*) c_AT_CCLK, strlen(c_AT_CCLK), cst_AT_No_AT_CCLK);
                s_onenet_connect_state = S_ONENET_CCLK_R;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME); //ԱATָصʱ300ms(ͺͽռõʱ)
            }
        }
        break;

        case S_ONENET_CCLK_R://ȴӦ
        {
            if (NbiotCheckAtAck() == UART_OK)//ȷӦ
            {
                s_at_error_count = 0;
                s_onenet_connect_state = S_ONENET_Wait; //״̬عʼ״̬
                
            }
            else if ((!check_timer_1ms()) || (NbiotCheckAtAck() == UART_ERROR))//Ӧʱ
            {
                if (++s_at_error_count >= NUM_AT_CCLK_ERROR)
                {
                    s_at_error_count = 0;
                  
                    s_onenet_connect_state = S_ONENET_Wait; //״̬عʼ״̬
                   
                }
                else
                {
                    s_onenet_connect_state = S_ONENET_CCLK;
                    set_timer_1s(1);
                }
            }
        }
        break;		
		
        case S_ONENET_Wait:
        {
            if ((!check_timer_1s()))
            {
                s_at_error_count	= 0;
                *Nbiot_Send_Data.state = NBIOT_ONLINE;
                g_s_nbiot_task_flag = TASK_SUCCESS; //Ϊֹɹ
                s_onenet_connect_state = S_ONENET_CONNECT_IDLE;
            }
        }
        break;

        default:
        {
            s_onenet_connect_state = S_ONENET_CONNECT_IDLE; //״̬عʼ״̬
        }
        break;
    }
}

#if SEND_ACKID_ENABLE
     u16 Send_AckID=0;
#endif

//Onnet״̬
#define S_ONENET_SEND_START     0
#define S_ONENET_SEND_DATA      1
#define S_ONENET_SEND_DATA_R    2

u8 s_onenet_send_state = S_ONENET_SEND_START;
void StartOnenetSendData(void)
{
	s_onenet_send_state = S_ONENET_SEND_START;
}

void OneNetSendDataMachine(void)
{
    char observe_num[10];
    static const char temp_AT_MIPLDISCOVERRSP1[] = "AT+MIPLNOTIFY=0,";
    static const char temp_AT_MIPLDISCOVERRSP2[] = ",3200,0,5750,1,";
    //static char c_AT_MIPLNOTIFY[50+SEND_DATA_LENGTH];//ڴ治㣬ʹù÷ͻ c_AT_NMGS

    switch (s_onenet_send_state)
    {
        case S_ONENET_SEND_START:
        {
            s_onenet_send_state = S_ONENET_SEND_DATA; //յݷͣģᱨERRORʱ1SERROR
            set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
        }
        break;


        case S_ONENET_SEND_DATA://
        {
            if (!check_timer_1ms())
            {
                if(TASK_IDLE == UartIfIdle(NB_UART_COM))
                {
                    //u16 len = 31; //ATָĳȣݷͳȵλ
                    u16 len, i, len_Gprs_Send_Data;
                    char len_buffer[6] = {0};



                    c_AT_NMGS[0] = 0; //ǿƹ
                    strcat(c_AT_NMGS, temp_AT_MIPLDISCOVERRSP1);
                    memset(observe_num, 0, sizeof(observe_num));
                    NbiotGetObserve_num(observe_num);
                    //NbiotGetDiscover_num(observe_num);

                    strcat(c_AT_NMGS, observe_num);
                    strcat(c_AT_NMGS, temp_AT_MIPLDISCOVERRSP2);

                    len_Gprs_Send_Data = 2 * Nbiot_Send_Data.len;
                    sprintf(len_buffer, "%u", len_Gprs_Send_Data);
                    strcat(c_AT_NMGS, len_buffer);
                    strcat(c_AT_NMGS, ",\"");
                    len = strlen(c_AT_NMGS);

                    for (i = 0; i < Nbiot_Send_Data.len; i++)//ȡ
                    {
                        if ((*(Nbiot_Send_Data.buf + i) >> 4) >= 0x0A)
                        {
                            c_AT_NMGS[len++] = (*(Nbiot_Send_Data.buf + i) >> 4) + 0x37;//ַת
                        }
                        else
                        {
                            c_AT_NMGS[len++] = (*(Nbiot_Send_Data.buf + i) >> 4) + 0x30;//ת
                        }

                        if ((*(Nbiot_Send_Data.buf + i) & 0x0F) >= 0x0A)
                        {
                            c_AT_NMGS[len++] = (*(Nbiot_Send_Data.buf + i) & 0x0F) + 0x37;
                        }
                        else
                        {
                            c_AT_NMGS[len++] = (*(Nbiot_Send_Data.buf + i) & 0x0F) + 0x30;
                        }
                    }

                    c_AT_NMGS[len++] = 0;//ֶַֹ
                    strcat(c_AT_NMGS, "\",0,0");
                    #if SEND_ACKID_ENABLE
                    char strtemp[8];

                    if(++Send_AckID == 0) Send_AckID = 1; //Send_AckID==0ʱģᱨERROR

                    sprintf(strtemp, ",%u", Send_AckID);
                    strcat(c_AT_MIPLNOTIFY, strtemp);
                    strcat(c_AT_MIPLNOTIFY, "\r");
                    NbiotClearMsg();
                    NbiotUartSend((u8*) c_AT_MIPLNOTIFY, strlen(c_AT_MIPLNOTIFY), cst_AT_No_AT_MIPLNOTIFY_ACKID);
                    #else
                    strcat(c_AT_NMGS, "\r");
                    NbiotClearMsg();
                    NbiotUartSend((u8*) c_AT_NMGS, strlen(c_AT_NMGS), cst_AT_No_AT_MIPLNOTIFY);
                    #endif
                    s_onenet_send_state = S_ONENET_SEND_DATA_R;
                    set_timer_1ms(5 * AT_COMMAND_RECEIVE_WAIT_TIME); //ʱϳ5ʱȴ
                }
            }
        } break; 
        
     case S_ONENET_SEND_DATA_R:
    {
        if (NbiotCheckAtAck() == UART_OK) //ȷӦ
        {
            g_s_nbiot_task_flag = TASK_SUCCESS;
            *Nbiot_Send_Data.state = NBIOT_SUCCESS;
            s_onenet_send_state = S_ONENET_SEND_START;
        }
        else if (NbiotCheckAtAck() == UART_ERROR || (!check_timer_1ms()))//شӦ߶ʱʱ䵽
        {
            *Nbiot_Send_Data.state = cst_AT_No_AT_MIPLNOTIFY;
            g_s_nbiot_task_flag = TASK_FAIL;
            s_onenet_send_state = S_ONENET_SEND_START;
        }
    } break; 
    default: break;   
    }
}
/***************************************************************************
 * @fun_name    static void NbiotPowerOffMachine()
 * @brief        ػ״̬
 ***************************************************************************/
void NbiotPowerOffMachine(void) //עȻϵػ
{
    //ػ
    static u8 s_at_error_count = 0;
	static const char* c_AT_MIPLCLOSE = "AT+MIPLCLOSE=0\r"; //¼ע
	static const char* c_AT_MIPLDELOBJ = "AT+MIPLDELOBJ=0,3200\r"; //ģඩԴбͷ
	static const char* c_AT_MIPLDEL = "AT+MIPLDELETE=0\r"; //ģͨʵɾ
	//static const char* c_AT_NETCLOSE = "AT+CTM2MDEREG\r";
	//static const char* c_AT_TCPCLOSE = "AT+ECSOCL=1\r";
    //static const char* c_AT_CFUN0 = "AT+CFUN=0\r"; //Сģʽ
    //static const char* c_AT_NCSEARFCN = "AT+QCSEARFCN=0\r"; //ѱƵ
    //static const char* c_AT_CFUN1 = "AT+CFUN=1\r"; //ģʽ
	//static const char* c_AT_QPOWD = "AT+QPOWD=1\r";
    switch (s_power_off_state)
    {
        case S_POWER_OFF_START:
        {
            s_at_error_count = 0;
			
			Nbiot_Para.net_state = NB_OFF_LINE;
			Nbiot_Para.coap_state = CONNECT_OFF_LINE;
			Nbiot_Para.udp1_state = CONNECT_OFF_LINE;
			Nbiot_Para.udp2_state = CONNECT_OFF_LINE;
//			Nbiot_Para.tcp1_state = CONNECT_OFF_LINE;

			set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
			s_power_off_state = S_AT_NETCLOSE;
        }
        break;
        case S_AT_MIPLCLOSE://¼ע   //עָΪ5s,2
        {
            if(!check_timer_1ms())
            {
              NbiotUartSend((u8*) c_AT_MIPLCLOSE, strlen(c_AT_MIPLCLOSE), cst_AT_No_AT_MIPLCLOSE);
              s_power_off_state = S_AT_MIPLCLOSE_R;
              set_timer_1ms(5*AT_COMMAND_RECEIVE_WAIT_TIME);
            }
        } break;
                
        case S_AT_MIPLCLOSE_R:
        {
            if (NbiotCheckAtAck() == UART_OK) 
            {
                //ȷӦ
                s_at_error_count = 0;
                s_power_off_state = S_AT_MIPLDELOBJ;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME);
            } 
            else if (NbiotCheckAtAck() == UART_ERROR || (!check_timer_1ms())) 
            {
                //شӦ߶ʱʱ䵽
               if (++s_at_error_count >= NUM_AT_MIPLCLOSE_ERROR)
                {
                    s_at_error_count = 0;
                    *Nbiot_Send_Data.state = cst_AT_No_AT_MIPLCLOSE;
                    s_power_off_state = S_AT_MIPLDELOBJ;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
                else 
                {
                    s_power_off_state = S_AT_MIPLCLOSE;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        } break;
                
        case S_AT_MIPLDELOBJ://ģඩԴбͷ
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_MIPLDELOBJ, strlen(c_AT_MIPLDELOBJ), cst_AT_No_AT_MIPLDELOBJ);
                s_power_off_state = S_AT_MIPLDELOBJ_R;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME);
            }
        } break;
                
        case S_AT_MIPLDELOBJ_R:
        {
            if (NbiotCheckAtAck() == UART_OK) 
            {
                //ȷӦ
                s_at_error_count = 0;
                s_power_off_state = S_AT_MIPLDEL;
                set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
            } 
            else if (NbiotCheckAtAck() == UART_ERROR || (!check_timer_1ms())) 
            {
                //شӦ߶ʱʱ䵽
               if (++s_at_error_count >= NUM_AT_MIPLDEL_ERROR)
                {
                    s_at_error_count = 0;
                    *Nbiot_Send_Data.state = cst_AT_No_AT_MIPLDELOBJ;
                    s_power_off_state = S_AT_MIPLDEL;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                } 
                else 
                {
                    s_power_off_state = S_AT_MIPLDELOBJ;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        } break;
                
        case S_AT_MIPLDEL://ģඩԴбͷ
        {
            if (!check_timer_1ms()) 
            {
                NbiotUartSend((u8*) c_AT_MIPLDEL, strlen(c_AT_MIPLDEL), cst_AT_No_AT_MIPLDEL);
                s_power_off_state = S_AT_MIPLDEL_R;
                set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME); 
            }
        } break;                
        case S_AT_MIPLDEL_R:
        {
            if (NbiotCheckAtAck() == UART_OK) 
            {
                //ȷӦ
                s_at_error_count = 0;
                s_power_off_state = S_AT_NETCLOSE;    
            } 
            else if (NbiotCheckAtAck() == UART_ERROR || (!check_timer_1ms())) 
            {
                //شӦ߶ʱʱ䵽
                if (++s_at_error_count >= NUM_AT_MIPLNOTIFY_ERROR)
                {
                    s_at_error_count = 0;
                    *Nbiot_Send_Data.state = cst_AT_No_AT_MIPLDEL;
                    s_power_off_state = S_AT_NETCLOSE;
                } 
                else 
                {
                    s_power_off_state = S_AT_MIPLDEL;
                    set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
                }
            }
        } break;  
        case S_AT_NETCLOSE:
        {
			if(Nbiot_Para.Telecom == SIM_CARD_MOBILE)
			{
				s_power_off_state = S_POWER_OFF;
			}
			else
			{
				int len=0; // "AT+ECSOCL=1\r";
				memset(stringbuffer_temp,0,sizeof(stringbuffer_temp));
				//"AT+ECSOCO=1,"183.230.174.137",6065"
				//IP Ĵ洢Ȼʹˮԭʽ桰.ţʹʱ
				stringbuffer_temp[len++]='A';
				stringbuffer_temp[len++]='T';
				stringbuffer_temp[len++]='+';
				stringbuffer_temp[len++]='E';
				stringbuffer_temp[len++]='C';
				stringbuffer_temp[len++]='S';
				stringbuffer_temp[len++]='O';
				stringbuffer_temp[len++]='C';
				stringbuffer_temp[len++]='L';
				stringbuffer_temp[len++]='=';
				stringbuffer_temp[len++]=NbiotGetE7025TcpSocket();
				stringbuffer_temp[len++]='\r';
				
				NbiotUartSend((u8*) stringbuffer_temp,len, cst_AT_No_AT);
				set_timer_1s(3);
				s_power_off_state = S_AT_NETCLOSE_R;
			}
        }
        break;

        case S_AT_NETCLOSE_R:
        {
            if (NbiotCheckAtAck() == UART_OK)
            {
                //ȷӦ
                s_at_error_count = 0;
				set_timer_1s(1);
                s_power_off_state = S_POWER_OFF;
            }
            else if (NbiotCheckAtAck() == UART_ERROR || (!check_timer_1s()))
            {
                //شӦ߶ʱʱ䵽
                s_at_error_count++;
                if (s_at_error_count >= 2)		//βɹֱӹػ
                {
                    s_at_error_count = 0;
                    s_power_off_state = S_POWER_OFF; //ػ
                }
                else
                {
                    s_power_off_state = S_AT_NETCLOSE;
                }
            }
        }
        break;
/*
        case S_AT_CFUN0://ģСģʽ
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_CFUN0, strlen((const char*) c_AT_CFUN0), cst_AT_No_AT_CFUN);
                s_power_off_state = S_AT_CFUN0_R;
                set_timer_1ms(2 * AT_COMMAND_RECEIVE_WAIT_TIME);
            }
        }
        break;

        case S_AT_CFUN0_R:
        {
            if (NbiotCheckAtAck() == UART_OK)
            {
                //ȷӦ
                s_at_error_count = 0;
				set_timer_1ms( AT_COMMAND_SEND_INTERVAL_TIME);
                s_power_off_state = S_AT_NCSEARFCN;
            }
            else if (NbiotCheckAtAck() == UART_ERROR || (!check_timer_1ms()))
            {
                //شӦ߶ʱʱ䵽
                if (++s_at_error_count >= NUM_AT_CFUN_ERROR)
                {
                    s_at_error_count = 0;
                    s_power_off_state = S_AT_NCSEARFCN;
                }
                else
                {
                    s_power_off_state = S_AT_CFUN0;
                    set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME);
                }
            }
        }
        break;

        case S_AT_NCSEARFCN://Ƶ
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_NCSEARFCN, strlen((const char*) c_AT_NCSEARFCN), cst_AT_No_AT_NCSEARFCN);
                s_power_off_state = S_AT_NCSEARFCN_R;
                set_timer_1ms(2 * AT_COMMAND_RECEIVE_WAIT_TIME);
            }
        }
        break;

        case S_AT_NCSEARFCN_R:
        {
            if (NbiotCheckAtAck() == UART_OK)
            {
                //ȷӦ
                s_at_error_count = 0;
				set_timer_1ms( AT_COMMAND_SEND_INTERVAL_TIME*6);//Ƶʱ3
                s_power_off_state = S_AT_CFUN1;
            }
            else if (NbiotCheckAtAck() == UART_ERROR || (!check_timer_1ms()))
            {
                //شӦ߶ʱʱ䵽
                if (++s_at_error_count >= NUM_AT_NCSEARFCN_ERROR)
                {
                    s_at_error_count = 0;
                    s_power_off_state = S_AT_CFUN1;
                }
                else
                {
                    s_power_off_state = S_AT_NCSEARFCN;
                    set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME);
                }
            }
        }
        break;

        case S_AT_CFUN1://ģģʽ
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_CFUN1, strlen((const char*) c_AT_CFUN1), cst_AT_No_AT_CFUN);
                s_power_off_state = S_AT_CFUN1_R;
                set_timer_1ms(2 * AT_COMMAND_RECEIVE_WAIT_TIME);
            }
        }
        break;

        case S_AT_CFUN1_R:
        {
            if (NbiotCheckAtAck() == UART_OK)
            {
                //ȷӦ
                s_at_error_count = 0;
				set_timer_1s(1);
                s_power_off_state = S_POWER_OFF;
            }
            else if (NbiotCheckAtAck() == UART_ERROR || (!check_timer_1ms()))
            {
                //شӦ߶ʱʱ䵽
                if (++s_at_error_count >= NUM_AT_CFUN_ERROR)
                {
                    s_at_error_count = 0;
                    set_timer_1s(1);
					s_power_off_state = S_POWER_OFF;
                }
                else
                {
                    s_power_off_state = S_AT_CFUN1;
                    set_timer_1ms(AT_COMMAND_RECEIVE_WAIT_TIME);
                }
            }
        }
        break;
*/
        case S_POWER_OFF:
        {
			if (!check_timer_1s())
			{
				NB_Power_Disable(); //жϵԴ
				set_timer_1s(1);
				s_power_off_state = S_POWER_OFF_WAIT;
				Nbiot_Para.net_state = NB_OFF_LINE;
				Nbiot_Para.udp1_state = CONNECT_OFF_LINE;
				Nbiot_Para.udp2_state = CONNECT_OFF_LINE;
//				Nbiot_Para.tcp1_state = CONNECT_OFF_LINE;
			}
        }
        break;

        case S_POWER_OFF_WAIT:
        {
            if (!check_timer_1s())
            {
                NbiotPreSleep();
                g_s_nbiot_task_flag = TASK_SUCCESS;
                s_power_off_state = S_START;
            }
        }
        break;

        default:
        {
            s_power_off_state = S_START;
        }
        break;
    }
}

void NbiotReadECLSNRMachine(void)
{
    static u8 s_error_count; //ATָۼƷʧܴ
    static u8 s_ecl_state = S_START;
    static const u8 c_AT_NUESTATS[] = "AT+QENG=0\r";
    switch (s_ecl_state)
    {
        case S_START:
        {
            set_timer_1ms(1000);
            s_error_count = 0;
            s_ecl_state = S_AT_ECL;
        }
        break;

        case S_AT_ECL:
        {
            if (!check_timer_1ms())
            {
                NbiotUartSend((u8*) c_AT_NUESTATS, strlen((const char*) c_AT_NUESTATS), cst_AT_No_AT_NUESTATS);
                set_timer_1ms(500);
                s_ecl_state = S_AT_ECL_R;
            }
        }
        break;

        case S_AT_ECL_R:
        {
            if (!check_timer_1ms())
            {
                if (NbiotCheckAtAck() == UART_OK)
                {
                    //ȷӦ
                    *Nbiot_Send_Data.state = ECL_SNR_SUCCESS;
                    g_s_nbiot_task_flag = TASK_SUCCESS;
                    s_ecl_state = S_START;
                }
                else
                {
                    //شӦ߶ʱʱ䵽
                    s_error_count++;
                    if (s_error_count >= 1)
                    {
                        s_error_count = 0;
                        *Nbiot_Send_Data.state = ECL_SNR_ERROR;
                        g_s_nbiot_task_flag = TASK_FAIL;
                        s_ecl_state = S_START;
                    }
                    else
                    {
                        s_ecl_state = S_AT_ECL;
                    }
                }
            }
        }
        break;

        default:
        {
            s_ecl_state = S_START;
        }
        break;
    }
}

/*****************************ONENETӦ·ָ*********************/
static u8 s_onenet_ack_rev_state = S_ONENET_ACKREV_START;

static void StartOnenetAckRev(void)
{
	s_onenet_ack_rev_state = S_ONENET_ACKREV_START;
}
/*******************************************************
NbiotRevAckMachine
ԽյָӦ
*******************************************************/
void NbiotRevAckMachine(void)
{
    static u8 s_error_count; //ATָۼƷʧܴ
    static char c_AT_MIPLWRITE_EXECUTE[30];// =   "AT+MIPLWRITERSP=0,12345,2\r";
    //static char c_AT_MIPLEXECUTE[30];// = "AT+MIPLEXECUTERSP=0,12345,2\r";
    switch (s_onenet_ack_rev_state)
    {
	  case S_ONENET_ACKREV_IDLE:
      {
      } break; 
      case S_ONENET_ACKREV_START:
      {
			set_timer_1ms(1000);
            s_onenet_ack_rev_state = S_ONENET_REPLY_REV_ACKID;
            s_error_count = 0;
      } break;  
         
     case S_ONENET_REPLY_REV_ACKID://Ӧյ
    {
        u8 len;
		char ack_num[10];
		if (!check_timer_1ms())
		{
			memset(ack_num,0,sizeof(ack_num));
			memset(c_AT_MIPLWRITE_EXECUTE,0,sizeof(c_AT_MIPLWRITE_EXECUTE));
			if(ORDER_EXECUTE == NbiotGetOnenetTypeDownOrder())
			{			
				strcpy(c_AT_MIPLWRITE_EXECUTE,"AT+MIPLEXECUTERSP=0,");
			}
			else 
			{
				strcpy(c_AT_MIPLWRITE_EXECUTE,"AT+MIPLWRITERSP=0,");
			}
			NbiotGetWriteAck_num(ack_num);
			strcat(c_AT_MIPLWRITE_EXECUTE,ack_num);
			strcat(c_AT_MIPLWRITE_EXECUTE,",2\r");
			
			len = strlen(c_AT_MIPLWRITE_EXECUTE);
			NbiotUartSend((u8*)c_AT_MIPLWRITE_EXECUTE, len, cst_AT_No_AT_MIPLWRITE);
			set_timer_1ms(5*AT_COMMAND_RECEIVE_WAIT_TIME);
			
			s_onenet_ack_rev_state = S_ONENET_REPLY_REV_ACKID_R; 
		}			
    } break; 
          
    case S_ONENET_REPLY_REV_ACKID_R://Ӧյ--ȴӦ
    {
        if (NbiotCheckAtAck() == UART_OK)
        {
            g_s_nbiot_task_flag = TASK_SUCCESS;
            s_onenet_ack_rev_state = S_ONENET_ACKREV_IDLE;
			SetUartCommRevFlag(); //Ӧд--ݴ
        }
        else if (NbiotCheckAtAck() == UART_ERROR || (!check_timer_1ms()))//شӦ߶ʱʱ䵽
        {
            if (++s_error_count >= NUM_AT_MIPLWRITE_ERROR)
            {
                *Nbiot_Send_Data.state = cst_AT_No_AT_MIPLWRITE;
                g_s_nbiot_task_flag = TASK_FAIL;
                s_onenet_ack_rev_state = S_ONENET_ACKREV_IDLE;
            }
            else
            {
                s_onenet_ack_rev_state = S_ONENET_REPLY_REV_ACKID;
                set_timer_1ms(AT_COMMAND_SEND_INTERVAL_TIME);
            }
        }
    }  break;  
    default: break;    
    }
}
/***************************************************************************
 * @fun_name    ʱԴ
 * @brief       ڲӿҪΪ˷估ʹ
 ***************************************************************************/
void set_timer_1s(u16 time)
{
    Set100msTimer(TIMER_100MS_NBIOT, time * 10);
}

u16 check_timer_1s(void)
{
    return Check100msTimer(TIMER_100MS_NBIOT);
}

void set_timer_1ms(u16 time)
{
    Set5msTimer(TIMER_5MS_NBIOT, time / 5);
}

u16 check_timer_1ms(void)
{
    return Check5msTimer(TIMER_5MS_NBIOT);
}

/***************************************************************************
 * @fun_name     void StartPowerOffTask()
 * @brief        ػӿ
 ***************************************************************************/
void StartPowerOffTask(void)
{	
    g_s_nbiot_task_flag = TASK_INIT;
    g_s_nbiot_main_state = NBIOT_POWER_OFF;
	s_power_off_state = S_POWER_OFF_START;	
}
//NBǿƹػ
void NbForcePowerOff(void)
{
	NB_Power_Disable();
	Nbiot_Para.net_state = NB_OFF_LINE;
	Nbiot_Para.udp1_state = CONNECT_OFF_LINE;
	Nbiot_Para.udp2_state = CONNECT_OFF_LINE;
//	Nbiot_Para.tcp1_state = CONNECT_OFF_LINE;
	g_s_nbiot_task_flag = TASK_INIT;
	g_s_nbiot_main_state = NBIOT_S_IDLE;
}


void set_clear_ncsearfcn (void)
{
    flag_clear_ncsearfcn =1;
}


void sys_get_three_code (void)
{
//    NbiotGetIMEI(Sys_data_object.NB_module_IMEI_0016);
//    NbiotGetIMSI(Sys_data_object.NB_module_IMSI);
//    NbiotGetICCID(Sys_data_object.SIMCard_ICCID_200A);
}
u32 sys_get_net_state (void)
{
	return 0;
}
#ifdef	__cplusplus
}
#endif

#endif
