/*******************************************************************************
* @Copyright (c)    :(C)2020, Qingdao ieslab Co., Ltd
* @FileName         :hc32_rtcc_driver.c
* @Author           :Kv-L
* @Version          :V1.0
* @Date             :2020-07-01 15:30:52
* @Description      :the function of the entity of GP22Gas_rtcc_driver.c
*******************************************************************************/
#ifdef __cplusplus
extern "C"
{
#endif

/* Includes ------------------------------------------------------------------*/
#include "UWater_lptimer_driver.h"


/* Private variables ---------------------------------------------------------*/
u8 lpTimer_flag = FALSE;

/* Private function prototypes -----------------------------------------------*/

//ڶʱ,ʱʹûʱ232.768CLK
void LPTimer0Init(u8 Rtc_Clk_Source, u32 time)
{
	stc_lptim_cfg_t    stcLptCfg;
	  
    DDL_ZERO_STRUCT(stcLptCfg);

    ///< ʹLPTIM0 ʱ
    Sysctrl_SetPeripheralGate(SysctrlPeripheralLpTim0, TRUE);

	stcLptCfg.enPrs    = LptimPrsDiv256;		//256Ƶ   32768/256 = 128
    stcLptCfg.enGate   = LptimGateLow;
    stcLptCfg.enGatep  = LptimGatePLow;
	if(Rtc_Clk_Source)//ڲʱ
	{
		stcLptCfg.enTcksel = LptimRcl;         	//ѡڲ RC ʱ RCL 32768    38400  ѡ32768(Clk_Init)
	}
	else//ⲿʱ
	{
	    stcLptCfg.enTcksel = LptimXtl;         //ѡⲿ RC ʱ RCL   32768    38400  ѡ32768
	}
    //stcLptCfg.enTcksel = LptimXtl;         		//ѡⲿ RC ʱ RCL   32768    38400  ѡ32768
	//stcLptCfg.enTcksel = LptimRcl;         		//ѡڲ RC ʱ RCL   32768    38400  ѡ32768
    stcLptCfg.enTogen  = LptimTogEnLow;
    stcLptCfg.enCt     = LptimTimerFun;         //ʱ
    stcLptCfg.enMd     = LptimMode2;            //ģʽΪģʽ2Զװ16λ/ʱ
    stcLptCfg.u16Arr   = 65536 - time;          //ԤװؼĴֵ
    Lptim_Init(M0P_LPTIMER0, &stcLptCfg);
	  
    Lptim_ClrItStatus(M0P_LPTIMER0);   //жϱ־λ
    Lptim_ConfIt(M0P_LPTIMER0, TRUE);  //LPTIMERж
    EnableNvic(LPTIM_0_1_IRQn, IrqLevel3, TRUE);
	  
	Lptim_Cmd(M0P_LPTIMER0, TRUE);
		
//		while (!M0P_LPTIMER0->CR_f.WT_FLAG)
//		{
//				;
//		}
//		M0P_LPTIMER0->ARR = 65536 - time;
//		M0P_LPTIMER0->CNT = 0;
//		M0P_LPTIMER0->CR = 0x422;   //жʹ ʱѡXTL 16λʱطʽ
//		M0P_LPTIMER0->CR_f.PRS = 2; //1
//		M0P_LPTIMER0->ICLR = 0;
//		EnableNvic(LPTIM_0_1_IRQn, IrqLevel3, TRUE);
}
/****************************************************************************
Function:    LPTimer1Init
Description: ͹ʱ1ʼ
Input:
Return:
Others:
*****************************************************************************/
void LPTimer1Init(u8 Rtc_Clk_Source)
{
	stc_lptim_cfg_t    stcLptCfg;
	  
    DDL_ZERO_STRUCT(stcLptCfg);

    ///< ʹLPTIM1 ʱ
    Sysctrl_SetPeripheralGate(SysctrlPeripheralLpTim1, TRUE);

	stcLptCfg.enPrs    = LptimPrsDiv256;		//256Ƶ   32768/256 = 128
    stcLptCfg.enGate   = LptimGateLow;
    stcLptCfg.enGatep  = LptimGatePLow;
	
	if(Rtc_Clk_Source)//ڲʱ
	{
		stcLptCfg.enTcksel = LptimRcl;         	//ѡڲ RC ʱ RCL 32768    38400  ѡ32768(Clk_Init)
	}
	else//ⲿʱ
	{
	    stcLptCfg.enTcksel = LptimXtl;         //ѡⲿ RC ʱ RCL   32768    38400  ѡ32768
	}
    stcLptCfg.enTogen  = LptimTogEnLow;
    stcLptCfg.enCt     = LptimTimerFun;         //ʱ
    stcLptCfg.enMd     = LptimMode1;            //ģʽΪģʽ116 λɼģʽ
    stcLptCfg.u16Arr   = 0;                     //ԤװؼĴֵ
    Lptim_Init(M0P_LPTIMER1, &stcLptCfg);
	  
    Lptim_ClrItStatus(M0P_LPTIMER1);   //жϱ־λ
    Lptim_ConfIt(M0P_LPTIMER1, FALSE);  //ȡLPTIMER1ж
    EnableNvic(LPTIM_0_1_IRQn, IrqLevel3, TRUE);
	  
	Lptim_Cmd(M0P_LPTIMER1, TRUE);	
}
/*************************************************
Function:  u32 LPTimerGetTick(u8 timerNum)
Description: ȡǰֵ
Input
Return:
Others:
*************************************************/
u16 LPTimer1GetTick()
{
    u16 b;
    b = M0P_LPTIMER1->CNT;
    return b ;
}

void LPTimer0_Work(u8 enCmd)
{
	if (enCmd == TRUE)
	{
		Sysctrl_SetPeripheralGate(SysctrlPeripheralLpTim0, TRUE);
		Lptim_Cmd(M0P_LPTIMER0, TRUE);
	}
	else
	{
		Sysctrl_SetPeripheralGate(SysctrlPeripheralLpTim0, FALSE);  //ʱ
		Lptim_Cmd(M0P_LPTIMER0, FALSE);
	}
}

u8 GetLpTimerFlag(void)
{
	return lpTimer_flag;
}

void ClearLpTimerFlag(void)
{
	lpTimer_flag = FALSE;
}
/*******************************************************************************
* @fun_name     LpTim0_IRQHandler
* @brief        
* @param[in]    None
* @param[out]   None
* @retval       None
* @other        None
*******************************************************************************/
void LpTim0_IRQHandler(void)
{
	if(Lptim_GetItStatus(M0P_LPTIMER0))
	{
		Lptim_ClrItStatus(M0P_LPTIMER0);
		lpTimer_flag = TRUE;		
	}
}

/*******************************************************************************
* @fun_name     LpTim0WakeSleep
* @brief        Ѻ
* @param[in]    None
* @param[out]   None
* @retval       None
* @other        None
*******************************************************************************/
void LpTim0WakeSleep(void)
{
    ;//ѲLpTime0ʹǰٿ
}

/*******************************************************************************
* @fun_name     LPTPreSleep
* @brief        LPTǰ
* @param[in]    None
* @param[out]   None
* @retval       None
* @other        None
*******************************************************************************/
void LpTime0PreSleep(void)
{
    Lptim_Cmd(M0P_LPTIMER0, FALSE);
    Sysctrl_SetPeripheralGate(SysctrlPeripheralLpTim0, FALSE);  //ʱ
}
/*******************************************************************************
* @fun_name     LpTim0IfSleep
* @brief        Ƿ
* @param[in]    None
* @param[out]   None
* @retval       None
* @other        None
*******************************************************************************/
u8 LpTime0IfSleep(void)
{
    return TRUE;
}
#ifdef __cplusplus
}
#endif
